CREATE OR REPLACE VIEW project_activity_vw AS
    (((SELECT f.ref_id AS project_id, 'forum'::text AS section, f.forum_id AS ref_id, fm.forum_message_id AS subref_id, fm.subject AS description, fm.post_date AS activity_date, u.user_id, u.unix_name, u.firstname, u.lastname FROM forum f, forum_thread ft, forum_message fm, "user" u WHERE ((((u.user_id = fm.created_by) AND (ft.forum_thread_id = fm.forum_thread_id)) AND (ft.forum_id = f.forum_id)) AND ((f.section)::text = 'project'::text)) 
UNION 
SELECT t.project_id, 'trackeropen'::text AS section, t.tracker_id AS ref_id, ti.tracker_item_id AS subref_id, ti.summary AS description, ti.open_date AS activity_date, u.user_id, u.unix_name, u.firstname, u.lastname FROM tracker t, tracker_item ti, "user" u WHERE ((u.user_id = ti.submitted_by) AND (ti.tracker_id = t.tracker_id))) 
UNION 
SELECT t.project_id, 'trackerclose'::text AS section, t.tracker_id AS ref_id, ti.tracker_item_id AS subref_id, ti.summary AS description, ti.close_date AS activity_date, u.user_id, u.unix_name, u.firstname, u.lastname FROM tracker t, tracker_item ti, "user" u WHERE ((u.user_id = ti.last_modified_by) AND (ti.tracker_id = t.tracker_id)) AND ti.close_date IS NOT NULL) 
UNION 
SELECT t.project_id, 'trackermod'::text AS section, t.tracker_id AS ref_id, ti.tracker_item_id AS subref_id, ti.summary AS description, ti.last_modified_date AS activity_date, u.user_id, u.unix_name, u.firstname, u.lastname FROM tracker t, tracker_item ti, "user" u WHERE ((u.user_id = ti.last_modified_by) AND (ti.tracker_id = t.tracker_id))) 
UNION 
SELECT sc.project_id, 'scmcommit'::text AS section, sc.scm_commit_id AS ref_id, 0 AS subref_id, sc.message_log AS description, sc.commit_date AS activity_date, u.user_id, u.unix_name, u.firstname, u.lastname FROM scm_commit sc, "user" u WHERE (u.user_id = sc.user_id);
