<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'core/AssociationPeer.php';

/**
 * Base class that represents a row from the 'association' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Association class. 
 * 
 * @package core 
 */
abstract class BaseAssociation extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var AssociationPeer
	 */
	protected static $peer;

	/**
	 * The value for the section field.
	 * @var string	  
	 */
	protected $section;	

	/**
	 * The value for the ref_id field.
	 * @var int	  
	 */
	protected $ref_id;	

	/**
	 * The value for the to_section field.
	 * @var string	  
	 */
	protected $to_section;	

	/**
	 * The value for the to_ref_id field.
	 * @var int	  
	 */
	protected $to_ref_id;	

	/**
	 * The value for the comment field.
	 * @var string	  
	 */
	protected $comment;	
  
	/**
	 * Get the Section column value.
	 *  
	 * @return string	  
	 */
	public function getSection()
	{
		return $this->section;
	}


	/**
	 * Set the value of `section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setSection($v)
	{
		if ($this->section !== $v) {
			$this->section = $v;
			$this->modifiedColumns[] = AssociationPeer::SECTION;
		}
				
	}

  
	/**
	 * Get the RefId column value.
	 *  
	 * @return int	  
	 */
	public function getRefId()
	{
		return $this->ref_id;
	}


	/**
	 * Set the value of `ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setRefId($v)
	{
		if ($this->ref_id !== $v) {
			$this->ref_id = $v;
			$this->modifiedColumns[] = AssociationPeer::REF_ID;
		}
				
	}

  
	/**
	 * Get the ToSection column value.
	 *  
	 * @return string	  
	 */
	public function getToSection()
	{
		return $this->to_section;
	}


	/**
	 * Set the value of `to_section` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setToSection($v)
	{
		if ($this->to_section !== $v) {
			$this->to_section = $v;
			$this->modifiedColumns[] = AssociationPeer::TO_SECTION;
		}
				
	}

  
	/**
	 * Get the ToRefId column value.
	 *  
	 * @return int	  
	 */
	public function getToRefId()
	{
		return $this->to_ref_id;
	}


	/**
	 * Set the value of `to_ref_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setToRefId($v)
	{
		if ($this->to_ref_id !== $v) {
			$this->to_ref_id = $v;
			$this->modifiedColumns[] = AssociationPeer::TO_REF_ID;
		}
				
	}

  
	/**
	 * Get the Comment column value.
	 *  
	 * @return string	  
	 */
	public function getComment()
	{
		return $this->comment;
	}


	/**
	 * Set the value of `comment` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setComment($v)
	{
		if ($this->comment !== $v) {
			$this->comment = $v;
			$this->modifiedColumns[] = AssociationPeer::COMMENT;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->section = $rs->getString($startcol + 0);					
			$this->ref_id = $rs->getInt($startcol + 1);					
			$this->to_section = $rs->getString($startcol + 2);					
			$this->to_ref_id = $rs->getInt($startcol + 3);					
			$this->comment = $rs->getString($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Association object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(AssociationPeer::DATABASE_NAME);
		$criteria->add(AssociationPeer::SECTION, $this->section);
		$criteria->add(AssociationPeer::REF_ID, $this->ref_id);
		$criteria->add(AssociationPeer::TO_SECTION, $this->to_section);
		$criteria->add(AssociationPeer::TO_REF_ID, $this->to_ref_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(AssociationPeer::DATABASE_NAME);
		if ($this->isColumnModified(AssociationPeer::SECTION)) $criteria->add(AssociationPeer::SECTION, $this->section);
		if ($this->isColumnModified(AssociationPeer::REF_ID)) $criteria->add(AssociationPeer::REF_ID, $this->ref_id);
		if ($this->isColumnModified(AssociationPeer::TO_SECTION)) $criteria->add(AssociationPeer::TO_SECTION, $this->to_section);
		if ($this->isColumnModified(AssociationPeer::TO_REF_ID)) $criteria->add(AssociationPeer::TO_REF_ID, $this->to_ref_id);
		if ($this->isColumnModified(AssociationPeer::COMMENT)) $criteria->add(AssociationPeer::COMMENT, $this->comment);
		return $criteria;			
	}
	
	

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("section", "ref_id", "to_section", "to_ref_id", "comment", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case AssociationPeer::SECTION:
				return $this->getSection();
				break;
		  
			case AssociationPeer::REF_ID:
				return $this->getRefId();
				break;
		  
			case AssociationPeer::TO_SECTION:
				return $this->getToSection();
				break;
		  
			case AssociationPeer::TO_REF_ID:
				return $this->getToRefId();
				break;
		  
			case AssociationPeer::COMMENT:
				return $this->getComment();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getSection();
				break;
  
			case 1:
				return $this->getRefId();
				break;
  
			case 2:
				return $this->getToSection();
				break;
  
			case 3:
				return $this->getToRefId();
				break;
  
			case 4:
				return $this->getComment();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(AssociationPeer::SECTION, $arr)) $this->setSection($arr[AssociationPeer::SECTION]);
  
		if (array_key_exists(AssociationPeer::REF_ID, $arr)) $this->setRefId($arr[AssociationPeer::REF_ID]);
  
		if (array_key_exists(AssociationPeer::TO_SECTION, $arr)) $this->setToSection($arr[AssociationPeer::TO_SECTION]);
  
		if (array_key_exists(AssociationPeer::TO_REF_ID, $arr)) $this->setToRefId($arr[AssociationPeer::TO_REF_ID]);
  
		if (array_key_exists(AssociationPeer::COMMENT, $arr)) $this->setComment($arr[AssociationPeer::COMMENT]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case AssociationPeer::SECTION:
				$this->setSection($value);
				break;
	  
			case AssociationPeer::REF_ID:
				$this->setRefId($value);
				break;
	  
			case AssociationPeer::TO_SECTION:
				$this->setToSection($value);
				break;
	  
			case AssociationPeer::TO_REF_ID:
				$this->setToRefId($value);
				break;
	  
			case AssociationPeer::COMMENT:
				$this->setComment($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setSection($value);
				break;
  
			case 1:
				$this->setRefId($value);
				break;
  
			case 2:
				$this->setToSection($value);
				break;
  
			case 3:
				$this->setToRefId($value);
				break;
  
			case 4:
				$this->setComment($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(AssociationPeer::DATABASE_NAME);

		try {
			$con->begin();
			AssociationPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(AssociationPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = AssociationPeer::doInsert($this, $con);
					$this->setNew(false);
				} else {
					AssociationPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return AssociationPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = AssociationPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  


	private $pks = array();
	
	/**
	 * Set the PrimaryKey.
	 *
	 * @param array $keys The elements of the composite key (order must match the order in XML file).
	 * @return void
	 * @throws PropelException
	 */
	public function setPrimaryKey($keys)
	{						

		$this->setSection($keys[0]);

		$this->setRefId($keys[1]);

		$this->setToSection($keys[2]);

		$this->setToRefId($keys[3]);

	}


	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return array 
	 */
	public function getPrimaryKey()
	{
		$this->pks[0] = $this->getSection();
		$this->pks[1] = $this->getRefId();
		$this->pks[2] = $this->getToSection();
		$this->pks[3] = $this->getToRefId();
		return $this->pks;

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Association Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Association();
		$copyObj->setComment($this->comment);
		
		$copyObj->setNew(true);
		
		$copyObj->setSection(NULL); // this is a pkey column, so set to default value
		$copyObj->setRefId(NULL); // this is a pkey column, so set to default value
		$copyObj->setToSection(NULL); // this is a pkey column, so set to default value
		$copyObj->setToRefId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return AssociationPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new AssociationPeer();
		}
		return self::$peer;
	}

}
