<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/User.php';
// (on-demand) include_once 'core/UserPeer.php';

include_once 'core/MyReportPeer.php';

/**
 * Base class that represents a row from the 'my_report' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MyReport class. 
 * 
 * @package core 
 */
abstract class BaseMyReport extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var MyReportPeer
	 */
	protected static $peer;

	/**
	 * The value for the my_report_id field.
	 * @var int	  
	 */
	protected $my_report_id;	

	/**
	 * The value for the user_id field.
	 * @var int	  
	 */
	protected $user_id;	

	/**
	 * The value for the report_name field.
	 * @var string	  
	 */
	protected $report_name;	

	/**
	 * The value for the is_shared field.
	 * @var boolean	  
	 */
	protected $is_shared = false;	

	/**
	 * The value for the open_date_start field.
	 * @var int	  
	 */
	protected $open_date_start;	

	/**
	 * The value for the open_date_end field.
	 * @var int	  
	 */
	protected $open_date_end;	

	/**
	 * The value for the close_date_start field.
	 * @var int	  
	 */
	protected $close_date_start;	

	/**
	 * The value for the close_date_end field.
	 * @var int	  
	 */
	protected $close_date_end;	

	/**
	 * The value for the report_type field.
	 * @var int	  
	 */
	protected $report_type;	
  
	/**
	 * Get the MyReportId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportId()
	{
		return $this->my_report_id;
	}


	/**
	 * Set the value of `my_report_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setMyReportId($v)
	{
		if ($this->my_report_id !== $v) {
			$this->my_report_id = $v;
			$this->modifiedColumns[] = MyReportPeer::MY_REPORT_ID;
		}
			
		  // update associated MyReportUser		  
		  if ($this->collMyReportUsers !== null) {
			  for ($i=0,$size=count($this->collMyReportUsers); $i < $size; $i++) {
				  $this->collMyReportUsers[$i]->setMyReportId($v);
			  }
		  }
			  	
		  // update associated MyReportProject		  
		  if ($this->collMyReportProjects !== null) {
			  for ($i=0,$size=count($this->collMyReportProjects); $i < $size; $i++) {
				  $this->collMyReportProjects[$i]->setMyReportId($v);
			  }
		  }
			  	
		  // update associated MyReportTracker		  
		  if ($this->collMyReportTrackers !== null) {
			  for ($i=0,$size=count($this->collMyReportTrackers); $i < $size; $i++) {
				  $this->collMyReportTrackers[$i]->setMyReportId($v);
			  }
		  }
			  	
		  // update associated MyReportFieldFilter		  
		  if ($this->collMyReportFieldFilters !== null) {
			  for ($i=0,$size=count($this->collMyReportFieldFilters); $i < $size; $i++) {
				  $this->collMyReportFieldFilters[$i]->setMyReportId($v);
			  }
		  }
			  	
		  // update associated MyReportFieldDisplay		  
		  if ($this->collMyReportFieldDisplays !== null) {
			  for ($i=0,$size=count($this->collMyReportFieldDisplays); $i < $size; $i++) {
				  $this->collMyReportFieldDisplays[$i]->setMyReportId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the UserId column value.
	 *  
	 * @return int	  
	 */
	public function getUserId()
	{
		return $this->user_id;
	}


	/**
	 * Set the value of `user_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setUserId($v)
	{
		if ($this->user_id !== $v) {
			$this->user_id = $v;
			$this->modifiedColumns[] = MyReportPeer::USER_ID;
		}
			
		if ($this->aUser !== null && $this->aUser->getUserId() !== $v) {
			$this->aUser = null;
		}
			
	}

  
	/**
	 * Get the ReportName column value.
	 *  
	 * @return string	  
	 */
	public function getReportName()
	{
		return $this->report_name;
	}


	/**
	 * Set the value of `report_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setReportName($v)
	{
		if ($this->report_name !== $v) {
			$this->report_name = $v;
			$this->modifiedColumns[] = MyReportPeer::REPORT_NAME;
		}
				
	}

  
	/**
	 * Get the IsShared column value.
	 *  
	 * @return boolean	  
	 */
	public function getIsShared()
	{
		return $this->is_shared;
	}


	/**
	 * Set the value of `is_shared` column.	  
	 *  
	 * @param boolean $v new value
	 * @return void
	 *  
	 */
	public function setIsShared($v)
	{
		if ($this->is_shared !== $v || $v === false) {
			$this->is_shared = $v;
			$this->modifiedColumns[] = MyReportPeer::IS_SHARED;
		}
				
	}


	/**
	 * Get the [optionally formatted] `open_date_start` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getOpenDateStart($format = 'Y-m-d H:i:s')
	{
		if ($this->open_date_start === null || $this->open_date_start === '') {
			return null;
		} elseif (!is_int($this->open_date_start)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->open_date_start);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of open_date_start as date/time value: " . var_export($this->open_date_start, true));
			}
		} else {
			$ts = $this->open_date_start;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `open_date_start` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setOpenDateStart($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for open_date_start from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->open_date_start !== $ts || $ts === -1) {
			$this->open_date_start = $ts;
			$this->modifiedColumns[] = MyReportPeer::OPEN_DATE_START;
		}
		
	}


	/**
	 * Get the [optionally formatted] `open_date_end` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getOpenDateEnd($format = 'Y-m-d H:i:s')
	{
		if ($this->open_date_end === null || $this->open_date_end === '') {
			return null;
		} elseif (!is_int($this->open_date_end)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->open_date_end);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of open_date_end as date/time value: " . var_export($this->open_date_end, true));
			}
		} else {
			$ts = $this->open_date_end;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `open_date_end` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setOpenDateEnd($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for open_date_end from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->open_date_end !== $ts || $ts === -1) {
			$this->open_date_end = $ts;
			$this->modifiedColumns[] = MyReportPeer::OPEN_DATE_END;
		}
		
	}


	/**
	 * Get the [optionally formatted] `close_date_start` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCloseDateStart($format = 'Y-m-d H:i:s')
	{
		if ($this->close_date_start === null || $this->close_date_start === '') {
			return null;
		} elseif (!is_int($this->close_date_start)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->close_date_start);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of close_date_start as date/time value: " . var_export($this->close_date_start, true));
			}
		} else {
			$ts = $this->close_date_start;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `close_date_start` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCloseDateStart($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for close_date_start from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->close_date_start !== $ts || $ts === -1) {
			$this->close_date_start = $ts;
			$this->modifiedColumns[] = MyReportPeer::CLOSE_DATE_START;
		}
		
	}


	/**
	 * Get the [optionally formatted] `close_date_end` column value.
	 *  
	 * @param string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCloseDateEnd($format = 'Y-m-d H:i:s')
	{
		if ($this->close_date_end === null || $this->close_date_end === '') {
			return null;
		} elseif (!is_int($this->close_date_end)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->close_date_end);
			if ($ts === -1) {
				throw new PropelException("Unable to parse value of close_date_end as date/time value: " . var_export($this->close_date_end, true));
			}
		} else {
			$ts = $this->close_date_end;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}


	/**
	 * Set the value of `close_date_end` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException - If passed [not-null] date/time is in an invalid format. 
	 */
	public function setCloseDateEnd($v)
	{
		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1) {
				throw new PropelException("Unable to parse date/time value for close_date_end from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->close_date_end !== $ts || $ts === -1) {
			$this->close_date_end = $ts;
			$this->modifiedColumns[] = MyReportPeer::CLOSE_DATE_END;
		}
		
	}

  
	/**
	 * Get the ReportType column value.
	 *  
	 * @return int	  
	 */
	public function getReportType()
	{
		return $this->report_type;
	}


	/**
	 * Set the value of `report_type` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setReportType($v)
	{
		if ($this->report_type !== $v) {
			$this->report_type = $v;
			$this->modifiedColumns[] = MyReportPeer::REPORT_TYPE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->my_report_id = $rs->getInt($startcol + 0);					
			$this->user_id = $rs->getInt($startcol + 1);					
			$this->report_name = $rs->getString($startcol + 2);					
			$this->is_shared = $rs->getBoolean($startcol + 3);					
			$this->open_date_start = $rs->getTimestamp($startcol + 4, null);
			$this->open_date_end = $rs->getTimestamp($startcol + 5, null);
			$this->close_date_start = $rs->getTimestamp($startcol + 6, null);
			$this->close_date_end = $rs->getTimestamp($startcol + 7, null);
			$this->report_type = $rs->getInt($startcol + 8);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating MyReport object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(MyReportPeer::DATABASE_NAME);
		$criteria->add(MyReportPeer::MY_REPORT_ID, $this->my_report_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(MyReportPeer::DATABASE_NAME);
		if ($this->isColumnModified(MyReportPeer::MY_REPORT_ID)) $criteria->add(MyReportPeer::MY_REPORT_ID, $this->my_report_id);
		if ($this->isColumnModified(MyReportPeer::USER_ID)) $criteria->add(MyReportPeer::USER_ID, $this->user_id);
		if ($this->isColumnModified(MyReportPeer::REPORT_NAME)) $criteria->add(MyReportPeer::REPORT_NAME, $this->report_name);
		if ($this->isColumnModified(MyReportPeer::IS_SHARED)) $criteria->add(MyReportPeer::IS_SHARED, $this->is_shared);
		if ($this->isColumnModified(MyReportPeer::OPEN_DATE_START)) $criteria->add(MyReportPeer::OPEN_DATE_START, $this->open_date_start);
		if ($this->isColumnModified(MyReportPeer::OPEN_DATE_END)) $criteria->add(MyReportPeer::OPEN_DATE_END, $this->open_date_end);
		if ($this->isColumnModified(MyReportPeer::CLOSE_DATE_START)) $criteria->add(MyReportPeer::CLOSE_DATE_START, $this->close_date_start);
		if ($this->isColumnModified(MyReportPeer::CLOSE_DATE_END)) $criteria->add(MyReportPeer::CLOSE_DATE_END, $this->close_date_end);
		if ($this->isColumnModified(MyReportPeer::REPORT_TYPE)) $criteria->add(MyReportPeer::REPORT_TYPE, $this->report_type);
		return $criteria;			
	}
	
	

	/**
	 * @var User	  
	 */
	protected $aUser;

	/**
	 * Declares an association between this object and a User object
	 *
	 * @param User $v
	 * @return void
	 * @throws PropelException
	 */
	public function setUser($v)
	{
			
		if ($v === null) {
			$this->setUserId(NULL);
		} else {
			$this->setUserId($v->getUserId());
		}
   
		$this->aUser = $v;
	}


	/**
	 * Get the associated User object
	 *
	 * @param Connection Optional Connection object.
	 * @return User The associated User object.
	 * @throws PropelException
	 */
	public function getUser($con = null)
	{
		// include the Peer class
		include_once 'core/UserPeer.php';

		if ($this->aUser === null && ($this->user_id !== null)) {
	
			$this->aUser = UserPeer::retrieveByPK($this->user_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = UserPeer::retrieveByPK($this->user_id, $con);
			   $obj->addMyReports($this);
			 */
		}
		return $this->aUser;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setUserKey($key)
	{

		$this->setUserId( (int) $key);			
		
	}

	/**
	 * Collection to store aggregation of collMyReportUsers	  
	 * @var array
	 */
	protected $collMyReportUsers; 

	/**
	 * Temporary storage of collMyReportUsers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportUsers()
	{
		if ($this->collMyReportUsers === null) {
			$this->collMyReportUsers = array();
		}
	}

	/**
	 * Method called to associate a MyReportUser object to this object
	 * through the MyReportUser foreign key attribute
	 *
	 * @param MyReportUser $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportUser(MyReportUser $l)
	{
		$this->collMyReportUsers[] = $l;
		$l->setMyReport($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportUsers.
	 * @var Criteria
	 */
	private $lastMyReportUsersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport has previously
	 * been saved, it will retrieve related MyReportUsers from storage.
	 * If this MyReport is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportUsers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportUsers === null) {
			if ($this->isNew()) {
			   $this->collMyReportUsers = array();
			} else {
	
				$criteria->add(MyReportUserPeer::MY_REPORT_ID, $this->getMyReportId() );

				$this->collMyReportUsers = MyReportUserPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportUserPeer::MY_REPORT_ID, $this->getMyReportId());

				if (!isset($this->lastMyReportUsersCriteria) || !$this->lastMyReportUsersCriteria->equals($criteria)) {
					$this->collMyReportUsers = MyReportUserPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportUsersCriteria = $criteria;

		return $this->collMyReportUsers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportUsersJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportUsers === null) {
			if ($this->isNew()) {
			   $this->collMyReportUsers = array();
			} else {
	   
				$criteria->add(MyReportUserPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportUserPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportUsersCriteria) || !$this->lastMyReportUsersCriteria->equals($criteria)) {
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastMyReportUsersCriteria = $criteria;

		return $this->collMyReportUsers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportUsers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportUsersJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportUserPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportUsers === null) {
			if ($this->isNew()) {
			   $this->collMyReportUsers = array();
			} else {
	   
				$criteria->add(MyReportUserPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportUserPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportUsersCriteria) || !$this->lastMyReportUsersCriteria->equals($criteria)) {
				$this->collMyReportUsers = MyReportUserPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportUsersCriteria = $criteria;

		return $this->collMyReportUsers;
	}

	/**
	 * Collection to store aggregation of collMyReportProjects	  
	 * @var array
	 */
	protected $collMyReportProjects; 

	/**
	 * Temporary storage of collMyReportProjects to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportProjects()
	{
		if ($this->collMyReportProjects === null) {
			$this->collMyReportProjects = array();
		}
	}

	/**
	 * Method called to associate a MyReportProject object to this object
	 * through the MyReportProject foreign key attribute
	 *
	 * @param MyReportProject $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportProject(MyReportProject $l)
	{
		$this->collMyReportProjects[] = $l;
		$l->setMyReport($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportProjects.
	 * @var Criteria
	 */
	private $lastMyReportProjectsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport has previously
	 * been saved, it will retrieve related MyReportProjects from storage.
	 * If this MyReport is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportProjects($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportProjects === null) {
			if ($this->isNew()) {
			   $this->collMyReportProjects = array();
			} else {
	
				$criteria->add(MyReportProjectPeer::MY_REPORT_ID, $this->getMyReportId() );

				$this->collMyReportProjects = MyReportProjectPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportProjectPeer::MY_REPORT_ID, $this->getMyReportId());

				if (!isset($this->lastMyReportProjectsCriteria) || !$this->lastMyReportProjectsCriteria->equals($criteria)) {
					$this->collMyReportProjects = MyReportProjectPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportProjectsCriteria = $criteria;

		return $this->collMyReportProjects;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportProjectsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportProjects === null) {
			if ($this->isNew()) {
			   $this->collMyReportProjects = array();
			} else {
	   
				$criteria->add(MyReportProjectPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportProjectPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportProjectsCriteria) || !$this->lastMyReportProjectsCriteria->equals($criteria)) {
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastMyReportProjectsCriteria = $criteria;

		return $this->collMyReportProjects;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportProjects from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportProjectsJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportProjectPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportProjects === null) {
			if ($this->isNew()) {
			   $this->collMyReportProjects = array();
			} else {
	   
				$criteria->add(MyReportProjectPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportProjectPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportProjectsCriteria) || !$this->lastMyReportProjectsCriteria->equals($criteria)) {
				$this->collMyReportProjects = MyReportProjectPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportProjectsCriteria = $criteria;

		return $this->collMyReportProjects;
	}

	/**
	 * Collection to store aggregation of collMyReportTrackers	  
	 * @var array
	 */
	protected $collMyReportTrackers; 

	/**
	 * Temporary storage of collMyReportTrackers to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportTrackers()
	{
		if ($this->collMyReportTrackers === null) {
			$this->collMyReportTrackers = array();
		}
	}

	/**
	 * Method called to associate a MyReportTracker object to this object
	 * through the MyReportTracker foreign key attribute
	 *
	 * @param MyReportTracker $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportTracker(MyReportTracker $l)
	{
		$this->collMyReportTrackers[] = $l;
		$l->setMyReport($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportTrackers.
	 * @var Criteria
	 */
	private $lastMyReportTrackersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport has previously
	 * been saved, it will retrieve related MyReportTrackers from storage.
	 * If this MyReport is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportTrackers($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportTrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportTrackers === null) {
			if ($this->isNew()) {
			   $this->collMyReportTrackers = array();
			} else {
	
				$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->getMyReportId() );

				$this->collMyReportTrackers = MyReportTrackerPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->getMyReportId());

				if (!isset($this->lastMyReportTrackersCriteria) || !$this->lastMyReportTrackersCriteria->equals($criteria)) {
					$this->collMyReportTrackers = MyReportTrackerPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportTrackersCriteria = $criteria;

		return $this->collMyReportTrackers;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportTrackers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportTrackersJoinTracker($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportTrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportTrackers === null) {
			if ($this->isNew()) {
			   $this->collMyReportTrackers = array();
			} else {
	   
				$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinTracker($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportTrackersCriteria) || !$this->lastMyReportTrackersCriteria->equals($criteria)) {
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinTracker($criteria, $con);
			}
		}
		$this->lastMyReportTrackersCriteria = $criteria;

		return $this->collMyReportTrackers;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportTrackers from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportTrackersJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportTrackerPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportTrackers === null) {
			if ($this->isNew()) {
			   $this->collMyReportTrackers = array();
			} else {
	   
				$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportTrackerPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportTrackersCriteria) || !$this->lastMyReportTrackersCriteria->equals($criteria)) {
				$this->collMyReportTrackers = MyReportTrackerPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportTrackersCriteria = $criteria;

		return $this->collMyReportTrackers;
	}

	/**
	 * Collection to store aggregation of collMyReportFieldFilters	  
	 * @var array
	 */
	protected $collMyReportFieldFilters; 

	/**
	 * Temporary storage of collMyReportFieldFilters to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportFieldFilters()
	{
		if ($this->collMyReportFieldFilters === null) {
			$this->collMyReportFieldFilters = array();
		}
	}

	/**
	 * Method called to associate a MyReportFieldFilter object to this object
	 * through the MyReportFieldFilter foreign key attribute
	 *
	 * @param MyReportFieldFilter $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportFieldFilter(MyReportFieldFilter $l)
	{
		$this->collMyReportFieldFilters[] = $l;
		$l->setMyReport($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportFieldFilters.
	 * @var Criteria
	 */
	private $lastMyReportFieldFiltersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport has previously
	 * been saved, it will retrieve related MyReportFieldFilters from storage.
	 * If this MyReport is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportFieldFilters($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldFilterPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportFieldFilters === null) {
			if ($this->isNew()) {
			   $this->collMyReportFieldFilters = array();
			} else {
	
				$criteria->add(MyReportFieldFilterPeer::MY_REPORT_ID, $this->getMyReportId() );

				$this->collMyReportFieldFilters = MyReportFieldFilterPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportFieldFilterPeer::MY_REPORT_ID, $this->getMyReportId());

				if (!isset($this->lastMyReportFieldFiltersCriteria) || !$this->lastMyReportFieldFiltersCriteria->equals($criteria)) {
					$this->collMyReportFieldFilters = MyReportFieldFilterPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportFieldFiltersCriteria = $criteria;

		return $this->collMyReportFieldFilters;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportFieldFilters from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportFieldFiltersJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldFilterPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportFieldFilters === null) {
			if ($this->isNew()) {
			   $this->collMyReportFieldFilters = array();
			} else {
	   
				$criteria->add(MyReportFieldFilterPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportFieldFilters = MyReportFieldFilterPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportFieldFilterPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportFieldFiltersCriteria) || !$this->lastMyReportFieldFiltersCriteria->equals($criteria)) {
				$this->collMyReportFieldFilters = MyReportFieldFilterPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportFieldFiltersCriteria = $criteria;

		return $this->collMyReportFieldFilters;
	}

	/**
	 * Collection to store aggregation of collMyReportFieldDisplays	  
	 * @var array
	 */
	protected $collMyReportFieldDisplays; 

	/**
	 * Temporary storage of collMyReportFieldDisplays to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initMyReportFieldDisplays()
	{
		if ($this->collMyReportFieldDisplays === null) {
			$this->collMyReportFieldDisplays = array();
		}
	}

	/**
	 * Method called to associate a MyReportFieldDisplay object to this object
	 * through the MyReportFieldDisplay foreign key attribute
	 *
	 * @param MyReportFieldDisplay $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addMyReportFieldDisplay(MyReportFieldDisplay $l)
	{
		$this->collMyReportFieldDisplays[] = $l;
		$l->setMyReport($this);
	}

	/**
	 * The criteria used to select the current contents of collMyReportFieldDisplays.
	 * @var Criteria
	 */
	private $lastMyReportFieldDisplaysCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport has previously
	 * been saved, it will retrieve related MyReportFieldDisplays from storage.
	 * If this MyReport is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getMyReportFieldDisplays($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldDisplayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collMyReportFieldDisplays === null) {
			if ($this->isNew()) {
			   $this->collMyReportFieldDisplays = array();
			} else {
	
				$criteria->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $this->getMyReportId() );

				$this->collMyReportFieldDisplays = MyReportFieldDisplayPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $this->getMyReportId());

				if (!isset($this->lastMyReportFieldDisplaysCriteria) || !$this->lastMyReportFieldDisplaysCriteria->equals($criteria)) {
					$this->collMyReportFieldDisplays = MyReportFieldDisplayPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastMyReportFieldDisplaysCriteria = $criteria;

		return $this->collMyReportFieldDisplays;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this MyReport is new, it will return
	 * an empty collection; or if this MyReport has previously
	 * been saved, it will retrieve related MyReportFieldDisplays from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in MyReport.
	 */
	public function getMyReportFieldDisplaysJoinMyReport($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldDisplayPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collMyReportFieldDisplays === null) {
			if ($this->isNew()) {
			   $this->collMyReportFieldDisplays = array();
			} else {
	   
				$criteria->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $this->getMyReportId());
				$this->collMyReportFieldDisplays = MyReportFieldDisplayPeer::doSelectJoinMyReport($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $this->getMyReportId());
			if (!isset($this->lastMyReportFieldDisplaysCriteria) || !$this->lastMyReportFieldDisplaysCriteria->equals($criteria)) {
				$this->collMyReportFieldDisplays = MyReportFieldDisplayPeer::doSelectJoinMyReport($criteria, $con);
			}
		}
		$this->lastMyReportFieldDisplaysCriteria = $criteria;

		return $this->collMyReportFieldDisplays;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("my_report_id", "user_id", "report_name", "is_shared", "open_date_start", "open_date_end", "close_date_start", "close_date_end", "report_type", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case MyReportPeer::MY_REPORT_ID:
				return $this->getMyReportId();
				break;
		  
			case MyReportPeer::USER_ID:
				return $this->getUserId();
				break;
		  
			case MyReportPeer::REPORT_NAME:
				return $this->getReportName();
				break;
		  
			case MyReportPeer::IS_SHARED:
				return $this->getIsShared();
				break;
		  
			case MyReportPeer::OPEN_DATE_START:
				return $this->getOpenDateStart();
				break;
		  
			case MyReportPeer::OPEN_DATE_END:
				return $this->getOpenDateEnd();
				break;
		  
			case MyReportPeer::CLOSE_DATE_START:
				return $this->getCloseDateStart();
				break;
		  
			case MyReportPeer::CLOSE_DATE_END:
				return $this->getCloseDateEnd();
				break;
		  
			case MyReportPeer::REPORT_TYPE:
				return $this->getReportType();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getMyReportId();
				break;
  
			case 1:
				return $this->getUserId();
				break;
  
			case 2:
				return $this->getReportName();
				break;
  
			case 3:
				return $this->getIsShared();
				break;
  
			case 4:
				return $this->getOpenDateStart();
				break;
  
			case 5:
				return $this->getOpenDateEnd();
				break;
  
			case 6:
				return $this->getCloseDateStart();
				break;
  
			case 7:
				return $this->getCloseDateEnd();
				break;
  
			case 8:
				return $this->getReportType();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(MyReportPeer::MY_REPORT_ID, $arr)) $this->setMyReportId($arr[MyReportPeer::MY_REPORT_ID]);
  
		if (array_key_exists(MyReportPeer::USER_ID, $arr)) $this->setUserId($arr[MyReportPeer::USER_ID]);
  
		if (array_key_exists(MyReportPeer::REPORT_NAME, $arr)) $this->setReportName($arr[MyReportPeer::REPORT_NAME]);
  
		if (array_key_exists(MyReportPeer::IS_SHARED, $arr)) $this->setIsShared($arr[MyReportPeer::IS_SHARED]);
  
		if (array_key_exists(MyReportPeer::OPEN_DATE_START, $arr)) $this->setOpenDateStart($arr[MyReportPeer::OPEN_DATE_START]);
  
		if (array_key_exists(MyReportPeer::OPEN_DATE_END, $arr)) $this->setOpenDateEnd($arr[MyReportPeer::OPEN_DATE_END]);
  
		if (array_key_exists(MyReportPeer::CLOSE_DATE_START, $arr)) $this->setCloseDateStart($arr[MyReportPeer::CLOSE_DATE_START]);
  
		if (array_key_exists(MyReportPeer::CLOSE_DATE_END, $arr)) $this->setCloseDateEnd($arr[MyReportPeer::CLOSE_DATE_END]);
  
		if (array_key_exists(MyReportPeer::REPORT_TYPE, $arr)) $this->setReportType($arr[MyReportPeer::REPORT_TYPE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case MyReportPeer::MY_REPORT_ID:
				$this->setMyReportId($value);
				break;
	  
			case MyReportPeer::USER_ID:
				$this->setUserId($value);
				break;
	  
			case MyReportPeer::REPORT_NAME:
				$this->setReportName($value);
				break;
	  
			case MyReportPeer::IS_SHARED:
				$this->setIsShared($value);
				break;
	  
			case MyReportPeer::OPEN_DATE_START:
				$this->setOpenDateStart($value);
				break;
	  
			case MyReportPeer::OPEN_DATE_END:
				$this->setOpenDateEnd($value);
				break;
	  
			case MyReportPeer::CLOSE_DATE_START:
				$this->setCloseDateStart($value);
				break;
	  
			case MyReportPeer::CLOSE_DATE_END:
				$this->setCloseDateEnd($value);
				break;
	  
			case MyReportPeer::REPORT_TYPE:
				$this->setReportType($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setMyReportId($value);
				break;
  
			case 1:
				$this->setUserId($value);
				break;
  
			case 2:
				$this->setReportName($value);
				break;
  
			case 3:
				$this->setIsShared($value);
				break;
  
			case 4:
				$this->setOpenDateStart($value);
				break;
  
			case 5:
				$this->setOpenDateEnd($value);
				break;
  
			case 6:
				$this->setCloseDateStart($value);
				break;
  
			case 7:
				$this->setCloseDateEnd($value);
				break;
  
			case 8:
				$this->setReportType($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportPeer::DATABASE_NAME);

		try {
			$con->begin();
			MyReportPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aUser !== null) {
				if ($this->aUser->isModified()) $this->aUser->save($con);
				$this->setUser($this->aUser);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MyReportPeer::doInsert($this, $con);
					$this->setMyReportId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					MyReportPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collMyReportUsers !== null) {
				for ($i=0,$size=count($this->collMyReportUsers); $i < $size; $i++) {
					$this->collMyReportUsers[$i]->save($con);
				}
			  }
			if ($this->collMyReportProjects !== null) {
				for ($i=0,$size=count($this->collMyReportProjects); $i < $size; $i++) {
					$this->collMyReportProjects[$i]->save($con);
				}
			  }
			if ($this->collMyReportTrackers !== null) {
				for ($i=0,$size=count($this->collMyReportTrackers); $i < $size; $i++) {
					$this->collMyReportTrackers[$i]->save($con);
				}
			  }
			if ($this->collMyReportFieldFilters !== null) {
				for ($i=0,$size=count($this->collMyReportFieldFilters); $i < $size; $i++) {
					$this->collMyReportFieldFilters[$i]->save($con);
				}
			  }
			if ($this->collMyReportFieldDisplays !== null) {
				for ($i=0,$size=count($this->collMyReportFieldDisplays); $i < $size; $i++) {
					$this->collMyReportFieldDisplays[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return MyReportPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aUser !== null) {
				if (($retval = $this->aUser->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = MyReportPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collMyReportUsers !== null) {
				for ($i=0,$size=count($this->collMyReportUsers); $i < $size; $i++) {
					if (($retval = $this->collMyReportUsers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportProjects !== null) {
				for ($i=0,$size=count($this->collMyReportProjects); $i < $size; $i++) {
					if (($retval = $this->collMyReportProjects[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportTrackers !== null) {
				for ($i=0,$size=count($this->collMyReportTrackers); $i < $size; $i++) {
					if (($retval = $this->collMyReportTrackers[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportFieldFilters !== null) {
				for ($i=0,$size=count($this->collMyReportFieldFilters); $i < $size; $i++) {
					if (($retval = $this->collMyReportFieldFilters[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collMyReportFieldDisplays !== null) {
				for ($i=0,$size=count($this->collMyReportFieldDisplays); $i < $size; $i++) {
					if (($retval = $this->collMyReportFieldDisplays[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed my_report_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setMyReportId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getMyReportId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return MyReport Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new MyReport();
		$copyObj->setUserId($this->user_id);
		$copyObj->setReportName($this->report_name);
		$copyObj->setIsShared($this->is_shared);
		$copyObj->setOpenDateStart($this->open_date_start);
		$copyObj->setOpenDateEnd($this->open_date_end);
		$copyObj->setCloseDateStart($this->close_date_start);
		$copyObj->setCloseDateEnd($this->close_date_end);
		$copyObj->setReportType($this->report_type);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getMyReportUsers() as $relObj) {
				$copyObj->addMyReportUser($relObj->copy());
			}

			foreach($this->getMyReportProjects() as $relObj) {
				$copyObj->addMyReportProject($relObj->copy());
			}

			foreach($this->getMyReportTrackers() as $relObj) {
				$copyObj->addMyReportTracker($relObj->copy());
			}

			foreach($this->getMyReportFieldFilters() as $relObj) {
				$copyObj->addMyReportFieldFilter($relObj->copy());
			}

			foreach($this->getMyReportFieldDisplays() as $relObj) {
				$copyObj->addMyReportFieldDisplay($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setMyReportId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return MyReportPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MyReportPeer();
		}
		return self::$peer;
	}

}
