<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'core/MyReportFieldFilter.php';
// (on-demand) include_once 'core/MyReportFieldFilterPeer.php';

include_once 'core/MyReportFieldValuePeer.php';

/**
 * Base class that represents a row from the 'my_report_field_value' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to MyReportFieldValue class. 
 * 
 * @package core 
 */
abstract class BaseMyReportFieldValue extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var MyReportFieldValuePeer
	 */
	protected static $peer;

	/**
	 * The value for the my_report_field_value_id field.
	 * @var int	  
	 */
	protected $my_report_field_value_id;	

	/**
	 * The value for the my_report_field_filter_id field.
	 * @var int	  
	 */
	protected $my_report_field_filter_id;	

	/**
	 * The value for the field_value field.
	 * @var string	  
	 */
	protected $field_value;	

	/**
	 * The value for the field_range_start field.
	 * @var string	  
	 */
	protected $field_range_start;	

	/**
	 * The value for the field_range_end field.
	 * @var string	  
	 */
	protected $field_range_end;	
  
	/**
	 * Get the MyReportFieldValueId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportFieldValueId()
	{
		return $this->my_report_field_value_id;
	}


	/**
	 * Set the value of `my_report_field_value_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setMyReportFieldValueId($v)
	{
		if ($this->my_report_field_value_id !== $v) {
			$this->my_report_field_value_id = $v;
			$this->modifiedColumns[] = MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID;
		}
				
	}

  
	/**
	 * Get the MyReportFieldFilterId column value.
	 *  
	 * @return int	  
	 */
	public function getMyReportFieldFilterId()
	{
		return $this->my_report_field_filter_id;
	}


	/**
	 * Set the value of `my_report_field_filter_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setMyReportFieldFilterId($v)
	{
		if ($this->my_report_field_filter_id !== $v) {
			$this->my_report_field_filter_id = $v;
			$this->modifiedColumns[] = MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID;
		}
			
		if ($this->aMyReportFieldFilter !== null && $this->aMyReportFieldFilter->getMyReportFieldFilterId() !== $v) {
			$this->aMyReportFieldFilter = null;
		}
			
	}

  
	/**
	 * Get the FieldValue column value.
	 *  
	 * @return string	  
	 */
	public function getFieldValue()
	{
		return $this->field_value;
	}


	/**
	 * Set the value of `field_value` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldValue($v)
	{
		if ($this->field_value !== $v) {
			$this->field_value = $v;
			$this->modifiedColumns[] = MyReportFieldValuePeer::FIELD_VALUE;
		}
				
	}

  
	/**
	 * Get the FieldRangeStart column value.
	 *  
	 * @return string	  
	 */
	public function getFieldRangeStart()
	{
		return $this->field_range_start;
	}


	/**
	 * Set the value of `field_range_start` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldRangeStart($v)
	{
		if ($this->field_range_start !== $v) {
			$this->field_range_start = $v;
			$this->modifiedColumns[] = MyReportFieldValuePeer::FIELD_RANGE_START;
		}
				
	}

  
	/**
	 * Get the FieldRangeEnd column value.
	 *  
	 * @return string	  
	 */
	public function getFieldRangeEnd()
	{
		return $this->field_range_end;
	}


	/**
	 * Set the value of `field_range_end` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldRangeEnd($v)
	{
		if ($this->field_range_end !== $v) {
			$this->field_range_end = $v;
			$this->modifiedColumns[] = MyReportFieldValuePeer::FIELD_RANGE_END;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->my_report_field_value_id = $rs->getInt($startcol + 0);					
			$this->my_report_field_filter_id = $rs->getInt($startcol + 1);					
			$this->field_value = $rs->getString($startcol + 2);					
			$this->field_range_start = $rs->getString($startcol + 3);					
			$this->field_range_end = $rs->getString($startcol + 4);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating MyReportFieldValue object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(MyReportFieldValuePeer::DATABASE_NAME);
		$criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID, $this->my_report_field_value_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(MyReportFieldValuePeer::DATABASE_NAME);
		if ($this->isColumnModified(MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID)) $criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID, $this->my_report_field_value_id);
		if ($this->isColumnModified(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID)) $criteria->add(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $this->my_report_field_filter_id);
		if ($this->isColumnModified(MyReportFieldValuePeer::FIELD_VALUE)) $criteria->add(MyReportFieldValuePeer::FIELD_VALUE, $this->field_value);
		if ($this->isColumnModified(MyReportFieldValuePeer::FIELD_RANGE_START)) $criteria->add(MyReportFieldValuePeer::FIELD_RANGE_START, $this->field_range_start);
		if ($this->isColumnModified(MyReportFieldValuePeer::FIELD_RANGE_END)) $criteria->add(MyReportFieldValuePeer::FIELD_RANGE_END, $this->field_range_end);
		return $criteria;			
	}
	
	

	/**
	 * @var MyReportFieldFilter	  
	 */
	protected $aMyReportFieldFilter;

	/**
	 * Declares an association between this object and a MyReportFieldFilter object
	 *
	 * @param MyReportFieldFilter $v
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReportFieldFilter($v)
	{
			
		if ($v === null) {
			$this->setMyReportFieldFilterId(NULL);
		} else {
			$this->setMyReportFieldFilterId($v->getMyReportFieldFilterId());
		}
   
		$this->aMyReportFieldFilter = $v;
	}


	/**
	 * Get the associated MyReportFieldFilter object
	 *
	 * @param Connection Optional Connection object.
	 * @return MyReportFieldFilter The associated MyReportFieldFilter object.
	 * @throws PropelException
	 */
	public function getMyReportFieldFilter($con = null)
	{
		// include the Peer class
		include_once 'core/MyReportFieldFilterPeer.php';

		if ($this->aMyReportFieldFilter === null && ($this->my_report_field_filter_id !== null)) {
	
			$this->aMyReportFieldFilter = MyReportFieldFilterPeer::retrieveByPK($this->my_report_field_filter_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = MyReportFieldFilterPeer::retrieveByPK($this->my_report_field_filter_id, $con);
			   $obj->addMyReportFieldValues($this);
			 */
		}
		return $this->aMyReportFieldFilter;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setMyReportFieldFilterKey($key)
	{

		$this->setMyReportFieldFilterId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("my_report_field_value_id", "my_report_field_filter_id", "field_value", "field_range_start", "field_range_end", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID:
				return $this->getMyReportFieldValueId();
				break;
		  
			case MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID:
				return $this->getMyReportFieldFilterId();
				break;
		  
			case MyReportFieldValuePeer::FIELD_VALUE:
				return $this->getFieldValue();
				break;
		  
			case MyReportFieldValuePeer::FIELD_RANGE_START:
				return $this->getFieldRangeStart();
				break;
		  
			case MyReportFieldValuePeer::FIELD_RANGE_END:
				return $this->getFieldRangeEnd();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getMyReportFieldValueId();
				break;
  
			case 1:
				return $this->getMyReportFieldFilterId();
				break;
  
			case 2:
				return $this->getFieldValue();
				break;
  
			case 3:
				return $this->getFieldRangeStart();
				break;
  
			case 4:
				return $this->getFieldRangeEnd();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID, $arr)) $this->setMyReportFieldValueId($arr[MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID]);
  
		if (array_key_exists(MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID, $arr)) $this->setMyReportFieldFilterId($arr[MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID]);
  
		if (array_key_exists(MyReportFieldValuePeer::FIELD_VALUE, $arr)) $this->setFieldValue($arr[MyReportFieldValuePeer::FIELD_VALUE]);
  
		if (array_key_exists(MyReportFieldValuePeer::FIELD_RANGE_START, $arr)) $this->setFieldRangeStart($arr[MyReportFieldValuePeer::FIELD_RANGE_START]);
  
		if (array_key_exists(MyReportFieldValuePeer::FIELD_RANGE_END, $arr)) $this->setFieldRangeEnd($arr[MyReportFieldValuePeer::FIELD_RANGE_END]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case MyReportFieldValuePeer::MY_REPORT_FIELD_VALUE_ID:
				$this->setMyReportFieldValueId($value);
				break;
	  
			case MyReportFieldValuePeer::MY_REPORT_FIELD_FILTER_ID:
				$this->setMyReportFieldFilterId($value);
				break;
	  
			case MyReportFieldValuePeer::FIELD_VALUE:
				$this->setFieldValue($value);
				break;
	  
			case MyReportFieldValuePeer::FIELD_RANGE_START:
				$this->setFieldRangeStart($value);
				break;
	  
			case MyReportFieldValuePeer::FIELD_RANGE_END:
				$this->setFieldRangeEnd($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setMyReportFieldValueId($value);
				break;
  
			case 1:
				$this->setMyReportFieldFilterId($value);
				break;
  
			case 2:
				$this->setFieldValue($value);
				break;
  
			case 3:
				$this->setFieldRangeStart($value);
				break;
  
			case 4:
				$this->setFieldRangeEnd($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportFieldValuePeer::DATABASE_NAME);

		try {
			$con->begin();
			MyReportFieldValuePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(MyReportFieldValuePeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aMyReportFieldFilter !== null) {
				if ($this->aMyReportFieldFilter->isModified()) $this->aMyReportFieldFilter->save($con);
				$this->setMyReportFieldFilter($this->aMyReportFieldFilter);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = MyReportFieldValuePeer::doInsert($this, $con);
					$this->setMyReportFieldValueId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					MyReportFieldValuePeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return MyReportFieldValuePeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aMyReportFieldFilter !== null) {
				if (($retval = $this->aMyReportFieldFilter->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = MyReportFieldValuePeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed my_report_field_value_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setMyReportFieldValueId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getMyReportFieldValueId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return MyReportFieldValue Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new MyReportFieldValue();
		$copyObj->setMyReportFieldFilterId($this->my_report_field_filter_id);
		$copyObj->setFieldValue($this->field_value);
		$copyObj->setFieldRangeStart($this->field_range_start);
		$copyObj->setFieldRangeEnd($this->field_range_end);
		
		$copyObj->setNew(true);
		
		$copyObj->setMyReportFieldValueId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return MyReportFieldValuePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new MyReportFieldValuePeer();
		}
		return self::$peer;
	}

}
