<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';

include_once 'core/PluginPeer.php';

/**
 * Base class that represents a row from the 'plugin' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to Plugin class. 
 * 
 * @package core 
 */
abstract class BasePlugin extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var PluginPeer
	 */
	protected static $peer;

	/**
	 * The value for the plugin_id field.
	 * @var int	  
	 */
	protected $plugin_id;	

	/**
	 * The value for the plugin_name field.
	 * @var string	  
	 */
	protected $plugin_name;	

	/**
	 * The value for the plugin_desc field.
	 * @var string	  
	 */
	protected $plugin_desc;	

	/**
	 * The value for the plugin_type field.
	 * @var string	  
	 */
	protected $plugin_type;	

	/**
	 * The value for the plugin_order field.
	 * @var int	  
	 */
	protected $plugin_order = 0;	

	/**
	 * The value for the exclusive_type field.
	 * @var string	  
	 */
	protected $exclusive_type;	
  
	/**
	 * Get the PluginId column value.
	 *  
	 * @return int	  
	 */
	public function getPluginId()
	{
		return $this->plugin_id;
	}


	/**
	 * Set the value of `plugin_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setPluginId($v)
	{
		if ($this->plugin_id !== $v) {
			$this->plugin_id = $v;
			$this->modifiedColumns[] = PluginPeer::PLUGIN_ID;
		}
			
		  // update associated PluginDependency		  
		  if ($this->collPluginDependencysRelatedByDependsonPluginId !== null) {
			  for ($i=0,$size=count($this->collPluginDependencysRelatedByDependsonPluginId); $i < $size; $i++) {
				  $this->collPluginDependencysRelatedByDependsonPluginId[$i]->setDependsonPluginId($v);
			  }
		  }
			  	
		  // update associated PluginDependency		  
		  if ($this->collPluginDependencysRelatedByPluginId !== null) {
			  for ($i=0,$size=count($this->collPluginDependencysRelatedByPluginId); $i < $size; $i++) {
				  $this->collPluginDependencysRelatedByPluginId[$i]->setPluginId($v);
			  }
		  }
			  	
		  // update associated ProjectPlugin		  
		  if ($this->collProjectPlugins !== null) {
			  for ($i=0,$size=count($this->collProjectPlugins); $i < $size; $i++) {
				  $this->collProjectPlugins[$i]->setPluginId($v);
			  }
		  }
			  	
		  // update associated ScmCommitFilter		  
		  if ($this->collScmCommitFilters !== null) {
			  for ($i=0,$size=count($this->collScmCommitFilters); $i < $size; $i++) {
				  $this->collScmCommitFilters[$i]->setPluginId($v);
			  }
		  }
			  	
		  // update associated UserPlugin		  
		  if ($this->collUserPlugins !== null) {
			  for ($i=0,$size=count($this->collUserPlugins); $i < $size; $i++) {
				  $this->collUserPlugins[$i]->setPluginId($v);
			  }
		  }
			  		
	}

  
	/**
	 * Get the PluginName column value.
	 *  
	 * @return string	  
	 */
	public function getPluginName()
	{
		return $this->plugin_name;
	}


	/**
	 * Set the value of `plugin_name` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPluginName($v)
	{
		if ($this->plugin_name !== $v) {
			$this->plugin_name = $v;
			$this->modifiedColumns[] = PluginPeer::PLUGIN_NAME;
		}
				
	}

  
	/**
	 * Get the PluginDesc column value.
	 *  
	 * @return string	  
	 */
	public function getPluginDesc()
	{
		return $this->plugin_desc;
	}


	/**
	 * Set the value of `plugin_desc` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPluginDesc($v)
	{
		if ($this->plugin_desc !== $v) {
			$this->plugin_desc = $v;
			$this->modifiedColumns[] = PluginPeer::PLUGIN_DESC;
		}
				
	}

  
	/**
	 * Get the PluginType column value.
	 *  
	 * @return string	  
	 */
	public function getPluginType()
	{
		return $this->plugin_type;
	}


	/**
	 * Set the value of `plugin_type` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setPluginType($v)
	{
		if ($this->plugin_type !== $v) {
			$this->plugin_type = $v;
			$this->modifiedColumns[] = PluginPeer::PLUGIN_TYPE;
		}
				
	}

  
	/**
	 * Get the PluginOrder column value.
	 *  
	 * @return int	  
	 */
	public function getPluginOrder()
	{
		return $this->plugin_order;
	}


	/**
	 * Set the value of `plugin_order` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setPluginOrder($v)
	{
		if ($this->plugin_order !== $v || $v === 0) {
			$this->plugin_order = $v;
			$this->modifiedColumns[] = PluginPeer::PLUGIN_ORDER;
		}
				
	}

  
	/**
	 * Get the ExclusiveType column value.
	 *  
	 * @return string	  
	 */
	public function getExclusiveType()
	{
		return $this->exclusive_type;
	}


	/**
	 * Set the value of `exclusive_type` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setExclusiveType($v)
	{
		if ($this->exclusive_type !== $v) {
			$this->exclusive_type = $v;
			$this->modifiedColumns[] = PluginPeer::EXCLUSIVE_TYPE;
		}
				
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->plugin_id = $rs->getInt($startcol + 0);					
			$this->plugin_name = $rs->getString($startcol + 1);					
			$this->plugin_desc = $rs->getString($startcol + 2);					
			$this->plugin_type = $rs->getString($startcol + 3);					
			$this->plugin_order = $rs->getInt($startcol + 4);					
			$this->exclusive_type = $rs->getString($startcol + 5);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating Plugin object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(PluginPeer::DATABASE_NAME);
		$criteria->add(PluginPeer::PLUGIN_ID, $this->plugin_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(PluginPeer::DATABASE_NAME);
		if ($this->isColumnModified(PluginPeer::PLUGIN_ID)) $criteria->add(PluginPeer::PLUGIN_ID, $this->plugin_id);
		if ($this->isColumnModified(PluginPeer::PLUGIN_NAME)) $criteria->add(PluginPeer::PLUGIN_NAME, $this->plugin_name);
		if ($this->isColumnModified(PluginPeer::PLUGIN_DESC)) $criteria->add(PluginPeer::PLUGIN_DESC, $this->plugin_desc);
		if ($this->isColumnModified(PluginPeer::PLUGIN_TYPE)) $criteria->add(PluginPeer::PLUGIN_TYPE, $this->plugin_type);
		if ($this->isColumnModified(PluginPeer::PLUGIN_ORDER)) $criteria->add(PluginPeer::PLUGIN_ORDER, $this->plugin_order);
		if ($this->isColumnModified(PluginPeer::EXCLUSIVE_TYPE)) $criteria->add(PluginPeer::EXCLUSIVE_TYPE, $this->exclusive_type);
		return $criteria;			
	}
	
	

	/**
	 * Collection to store aggregation of collPluginDependencysRelatedByDependsonPluginId	  
	 * @var array
	 */
	protected $collPluginDependencysRelatedByDependsonPluginId; 

	/**
	 * Temporary storage of collPluginDependencysRelatedByDependsonPluginId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPluginDependencysRelatedByDependsonPluginId()
	{
		if ($this->collPluginDependencysRelatedByDependsonPluginId === null) {
			$this->collPluginDependencysRelatedByDependsonPluginId = array();
		}
	}

	/**
	 * Method called to associate a PluginDependency object to this object
	 * through the PluginDependency foreign key attribute
	 *
	 * @param PluginDependency $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addPluginDependencyRelatedByDependsonPluginId(PluginDependency $l)
	{
		$this->collPluginDependencysRelatedByDependsonPluginId[] = $l;
		$l->setPluginRelatedByDependsonPluginId($this);
	}

	/**
	 * The criteria used to select the current contents of collPluginDependencysRelatedByDependsonPluginId.
	 * @var Criteria
	 */
	private $lastPluginDependencysRelatedByDependsonPluginIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin has previously
	 * been saved, it will retrieve related PluginDependencysRelatedByDependsonPluginId from storage.
	 * If this Plugin is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPluginDependencysRelatedByDependsonPluginId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/PluginDependencyPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collPluginDependencysRelatedByDependsonPluginId === null) {
			if ($this->isNew()) {
			   $this->collPluginDependencysRelatedByDependsonPluginId = array();
			} else {
	
				$criteria->add(PluginDependencyPeer::DEPENDSON_PLUGIN_ID, $this->getPluginId() );

				$this->collPluginDependencysRelatedByDependsonPluginId = PluginDependencyPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(PluginDependencyPeer::DEPENDSON_PLUGIN_ID, $this->getPluginId());

				if (!isset($this->lastPluginDependencysRelatedByDependsonPluginIdCriteria) || !$this->lastPluginDependencysRelatedByDependsonPluginIdCriteria->equals($criteria)) {
					$this->collPluginDependencysRelatedByDependsonPluginId = PluginDependencyPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPluginDependencysRelatedByDependsonPluginIdCriteria = $criteria;

		return $this->collPluginDependencysRelatedByDependsonPluginId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related PluginDependencysRelatedByDependsonPluginId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getPluginDependencysRelatedByDependsonPluginIdJoinPluginRelatedByPluginId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/PluginDependencyPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collPluginDependencysRelatedByDependsonPluginId === null) {
			if ($this->isNew()) {
			   $this->collPluginDependencysRelatedByDependsonPluginId = array();
			} else {
	   
				$criteria->add(PluginDependencyPeer::DEPENDSON_PLUGIN_ID, $this->getPluginId());
				$this->collPluginDependencysRelatedByDependsonPluginId = PluginDependencyPeer::doSelectJoinPluginRelatedByPluginId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(PluginDependencyPeer::DEPENDSON_PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastPluginDependencysRelatedByDependsonPluginIdCriteria) || !$this->lastPluginDependencysRelatedByDependsonPluginIdCriteria->equals($criteria)) {
				$this->collPluginDependencysRelatedByDependsonPluginId = PluginDependencyPeer::doSelectJoinPluginRelatedByPluginId($criteria, $con);
			}
		}
		$this->lastPluginDependencysRelatedByDependsonPluginIdCriteria = $criteria;

		return $this->collPluginDependencysRelatedByDependsonPluginId;
	}

	/**
	 * Collection to store aggregation of collPluginDependencysRelatedByPluginId	  
	 * @var array
	 */
	protected $collPluginDependencysRelatedByPluginId; 

	/**
	 * Temporary storage of collPluginDependencysRelatedByPluginId to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initPluginDependencysRelatedByPluginId()
	{
		if ($this->collPluginDependencysRelatedByPluginId === null) {
			$this->collPluginDependencysRelatedByPluginId = array();
		}
	}

	/**
	 * Method called to associate a PluginDependency object to this object
	 * through the PluginDependency foreign key attribute
	 *
	 * @param PluginDependency $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addPluginDependencyRelatedByPluginId(PluginDependency $l)
	{
		$this->collPluginDependencysRelatedByPluginId[] = $l;
		$l->setPluginRelatedByPluginId($this);
	}

	/**
	 * The criteria used to select the current contents of collPluginDependencysRelatedByPluginId.
	 * @var Criteria
	 */
	private $lastPluginDependencysRelatedByPluginIdCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin has previously
	 * been saved, it will retrieve related PluginDependencysRelatedByPluginId from storage.
	 * If this Plugin is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getPluginDependencysRelatedByPluginId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/PluginDependencyPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collPluginDependencysRelatedByPluginId === null) {
			if ($this->isNew()) {
			   $this->collPluginDependencysRelatedByPluginId = array();
			} else {
	
				$criteria->add(PluginDependencyPeer::PLUGIN_ID, $this->getPluginId() );

				$this->collPluginDependencysRelatedByPluginId = PluginDependencyPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(PluginDependencyPeer::PLUGIN_ID, $this->getPluginId());

				if (!isset($this->lastPluginDependencysRelatedByPluginIdCriteria) || !$this->lastPluginDependencysRelatedByPluginIdCriteria->equals($criteria)) {
					$this->collPluginDependencysRelatedByPluginId = PluginDependencyPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastPluginDependencysRelatedByPluginIdCriteria = $criteria;

		return $this->collPluginDependencysRelatedByPluginId;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related PluginDependencysRelatedByPluginId from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getPluginDependencysRelatedByPluginIdJoinPluginRelatedByDependsonPluginId($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/PluginDependencyPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collPluginDependencysRelatedByPluginId === null) {
			if ($this->isNew()) {
			   $this->collPluginDependencysRelatedByPluginId = array();
			} else {
	   
				$criteria->add(PluginDependencyPeer::PLUGIN_ID, $this->getPluginId());
				$this->collPluginDependencysRelatedByPluginId = PluginDependencyPeer::doSelectJoinPluginRelatedByDependsonPluginId($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(PluginDependencyPeer::PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastPluginDependencysRelatedByPluginIdCriteria) || !$this->lastPluginDependencysRelatedByPluginIdCriteria->equals($criteria)) {
				$this->collPluginDependencysRelatedByPluginId = PluginDependencyPeer::doSelectJoinPluginRelatedByDependsonPluginId($criteria, $con);
			}
		}
		$this->lastPluginDependencysRelatedByPluginIdCriteria = $criteria;

		return $this->collPluginDependencysRelatedByPluginId;
	}

	/**
	 * Collection to store aggregation of collProjectPlugins	  
	 * @var array
	 */
	protected $collProjectPlugins; 

	/**
	 * Temporary storage of collProjectPlugins to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initProjectPlugins()
	{
		if ($this->collProjectPlugins === null) {
			$this->collProjectPlugins = array();
		}
	}

	/**
	 * Method called to associate a ProjectPlugin object to this object
	 * through the ProjectPlugin foreign key attribute
	 *
	 * @param ProjectPlugin $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addProjectPlugin(ProjectPlugin $l)
	{
		$this->collProjectPlugins[] = $l;
		$l->setPlugin($this);
	}

	/**
	 * The criteria used to select the current contents of collProjectPlugins.
	 * @var Criteria
	 */
	private $lastProjectPluginsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin has previously
	 * been saved, it will retrieve related ProjectPlugins from storage.
	 * If this Plugin is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getProjectPlugins($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collProjectPlugins === null) {
			if ($this->isNew()) {
			   $this->collProjectPlugins = array();
			} else {
	
				$criteria->add(ProjectPluginPeer::PLUGIN_ID, $this->getPluginId() );

				$this->collProjectPlugins = ProjectPluginPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ProjectPluginPeer::PLUGIN_ID, $this->getPluginId());

				if (!isset($this->lastProjectPluginsCriteria) || !$this->lastProjectPluginsCriteria->equals($criteria)) {
					$this->collProjectPlugins = ProjectPluginPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastProjectPluginsCriteria = $criteria;

		return $this->collProjectPlugins;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related ProjectPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getProjectPluginsJoinPlugin($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectPlugins === null) {
			if ($this->isNew()) {
			   $this->collProjectPlugins = array();
			} else {
	   
				$criteria->add(ProjectPluginPeer::PLUGIN_ID, $this->getPluginId());
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectPluginPeer::PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastProjectPluginsCriteria) || !$this->lastProjectPluginsCriteria->equals($criteria)) {
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		}
		$this->lastProjectPluginsCriteria = $criteria;

		return $this->collProjectPlugins;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related ProjectPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getProjectPluginsJoinProject($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/ProjectPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collProjectPlugins === null) {
			if ($this->isNew()) {
			   $this->collProjectPlugins = array();
			} else {
	   
				$criteria->add(ProjectPluginPeer::PLUGIN_ID, $this->getPluginId());
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinProject($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ProjectPluginPeer::PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastProjectPluginsCriteria) || !$this->lastProjectPluginsCriteria->equals($criteria)) {
				$this->collProjectPlugins = ProjectPluginPeer::doSelectJoinProject($criteria, $con);
			}
		}
		$this->lastProjectPluginsCriteria = $criteria;

		return $this->collProjectPlugins;
	}

	/**
	 * Collection to store aggregation of collScmCommitFilters	  
	 * @var array
	 */
	protected $collScmCommitFilters; 

	/**
	 * Temporary storage of collScmCommitFilters to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initScmCommitFilters()
	{
		if ($this->collScmCommitFilters === null) {
			$this->collScmCommitFilters = array();
		}
	}

	/**
	 * Method called to associate a ScmCommitFilter object to this object
	 * through the ScmCommitFilter foreign key attribute
	 *
	 * @param ScmCommitFilter $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addScmCommitFilter(ScmCommitFilter $l)
	{
		$this->collScmCommitFilters[] = $l;
		$l->setPlugin($this);
	}

	/**
	 * The criteria used to select the current contents of collScmCommitFilters.
	 * @var Criteria
	 */
	private $lastScmCommitFiltersCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin has previously
	 * been saved, it will retrieve related ScmCommitFilters from storage.
	 * If this Plugin is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getScmCommitFilters($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collScmCommitFilters === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilters = array();
			} else {
	
				$criteria->add(ScmCommitFilterPeer::PLUGIN_ID, $this->getPluginId() );

				$this->collScmCommitFilters = ScmCommitFilterPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(ScmCommitFilterPeer::PLUGIN_ID, $this->getPluginId());

				if (!isset($this->lastScmCommitFiltersCriteria) || !$this->lastScmCommitFiltersCriteria->equals($criteria)) {
					$this->collScmCommitFilters = ScmCommitFilterPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastScmCommitFiltersCriteria = $criteria;

		return $this->collScmCommitFilters;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related ScmCommitFilters from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getScmCommitFiltersJoinPlugin($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'plugins/scm/lib/ScmCommitFilterPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collScmCommitFilters === null) {
			if ($this->isNew()) {
			   $this->collScmCommitFilters = array();
			} else {
	   
				$criteria->add(ScmCommitFilterPeer::PLUGIN_ID, $this->getPluginId());
				$this->collScmCommitFilters = ScmCommitFilterPeer::doSelectJoinPlugin($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(ScmCommitFilterPeer::PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastScmCommitFiltersCriteria) || !$this->lastScmCommitFiltersCriteria->equals($criteria)) {
				$this->collScmCommitFilters = ScmCommitFilterPeer::doSelectJoinPlugin($criteria, $con);
			}
		}
		$this->lastScmCommitFiltersCriteria = $criteria;

		return $this->collScmCommitFilters;
	}

	/**
	 * Collection to store aggregation of collUserPlugins	  
	 * @var array
	 */
	protected $collUserPlugins; 

	/**
	 * Temporary storage of collUserPlugins to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return void
	 */
	public function initUserPlugins()
	{
		if ($this->collUserPlugins === null) {
			$this->collUserPlugins = array();
		}
	}

	/**
	 * Method called to associate a UserPlugin object to this object
	 * through the UserPlugin foreign key attribute
	 *
	 * @param UserPlugin $l $className
	 * @return void
	 * @throws PropelException
	 */
	public function addUserPlugin(UserPlugin $l)
	{
		$this->collUserPlugins[] = $l;
		$l->setPlugin($this);
	}

	/**
	 * The criteria used to select the current contents of collUserPlugins.
	 * @var Criteria
	 */
	private $lastUserPluginsCriteria = null;

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin has previously
	 * been saved, it will retrieve related UserPlugins from storage.
	 * If this Plugin is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param Connection $con
	 * @param Criteria $criteria
	 * @throws PropelException
	 */
	public function getUserPlugins($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
				
		if ($this->collUserPlugins === null) {
			if ($this->isNew()) {
			   $this->collUserPlugins = array();
			} else {
	
				$criteria->add(UserPluginPeer::PLUGIN_ID, $this->getPluginId() );

				$this->collUserPlugins = UserPluginPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.

				$criteria->add(UserPluginPeer::PLUGIN_ID, $this->getPluginId());

				if (!isset($this->lastUserPluginsCriteria) || !$this->lastUserPluginsCriteria->equals($criteria)) {
					$this->collUserPlugins = UserPluginPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastUserPluginsCriteria = $criteria;

		return $this->collUserPlugins;
	}
	

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related UserPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getUserPluginsJoinPlugin($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserPlugins === null) {
			if ($this->isNew()) {
			   $this->collUserPlugins = array();
			} else {
	   
				$criteria->add(UserPluginPeer::PLUGIN_ID, $this->getPluginId());
				$this->collUserPlugins = UserPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPluginPeer::PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastUserPluginsCriteria) || !$this->lastUserPluginsCriteria->equals($criteria)) {
				$this->collUserPlugins = UserPluginPeer::doSelectJoinPlugin($criteria, $con);
			}
		}
		$this->lastUserPluginsCriteria = $criteria;

		return $this->collUserPlugins;
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this Plugin is new, it will return
	 * an empty collection; or if this Plugin has previously
	 * been saved, it will retrieve related UserPlugins from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in Plugin.
	 */
	public function getUserPluginsJoinUser($criteria = null, $con = null)
	{
		// include the Peer class
		include_once 'core/UserPluginPeer.php';
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		
		if ($this->collUserPlugins === null) {
			if ($this->isNew()) {
			   $this->collUserPlugins = array();
			} else {
	   
				$criteria->add(UserPluginPeer::PLUGIN_ID, $this->getPluginId());
				$this->collUserPlugins = UserPluginPeer::doSelectJoinUser($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.
	  
			$criteria->add(UserPluginPeer::PLUGIN_ID, $this->getPluginId());
			if (!isset($this->lastUserPluginsCriteria) || !$this->lastUserPluginsCriteria->equals($criteria)) {
				$this->collUserPlugins = UserPluginPeer::doSelectJoinUser($criteria, $con);
			}
		}
		$this->lastUserPluginsCriteria = $criteria;

		return $this->collUserPlugins;
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("plugin_id", "plugin_name", "plugin_desc", "plugin_type", "plugin_order", "exclusive_type", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case PluginPeer::PLUGIN_ID:
				return $this->getPluginId();
				break;
		  
			case PluginPeer::PLUGIN_NAME:
				return $this->getPluginName();
				break;
		  
			case PluginPeer::PLUGIN_DESC:
				return $this->getPluginDesc();
				break;
		  
			case PluginPeer::PLUGIN_TYPE:
				return $this->getPluginType();
				break;
		  
			case PluginPeer::PLUGIN_ORDER:
				return $this->getPluginOrder();
				break;
		  
			case PluginPeer::EXCLUSIVE_TYPE:
				return $this->getExclusiveType();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getPluginId();
				break;
  
			case 1:
				return $this->getPluginName();
				break;
  
			case 2:
				return $this->getPluginDesc();
				break;
  
			case 3:
				return $this->getPluginType();
				break;
  
			case 4:
				return $this->getPluginOrder();
				break;
  
			case 5:
				return $this->getExclusiveType();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(PluginPeer::PLUGIN_ID, $arr)) $this->setPluginId($arr[PluginPeer::PLUGIN_ID]);
  
		if (array_key_exists(PluginPeer::PLUGIN_NAME, $arr)) $this->setPluginName($arr[PluginPeer::PLUGIN_NAME]);
  
		if (array_key_exists(PluginPeer::PLUGIN_DESC, $arr)) $this->setPluginDesc($arr[PluginPeer::PLUGIN_DESC]);
  
		if (array_key_exists(PluginPeer::PLUGIN_TYPE, $arr)) $this->setPluginType($arr[PluginPeer::PLUGIN_TYPE]);
  
		if (array_key_exists(PluginPeer::PLUGIN_ORDER, $arr)) $this->setPluginOrder($arr[PluginPeer::PLUGIN_ORDER]);
  
		if (array_key_exists(PluginPeer::EXCLUSIVE_TYPE, $arr)) $this->setExclusiveType($arr[PluginPeer::EXCLUSIVE_TYPE]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case PluginPeer::PLUGIN_ID:
				$this->setPluginId($value);
				break;
	  
			case PluginPeer::PLUGIN_NAME:
				$this->setPluginName($value);
				break;
	  
			case PluginPeer::PLUGIN_DESC:
				$this->setPluginDesc($value);
				break;
	  
			case PluginPeer::PLUGIN_TYPE:
				$this->setPluginType($value);
				break;
	  
			case PluginPeer::PLUGIN_ORDER:
				$this->setPluginOrder($value);
				break;
	  
			case PluginPeer::EXCLUSIVE_TYPE:
				$this->setExclusiveType($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setPluginId($value);
				break;
  
			case 1:
				$this->setPluginName($value);
				break;
  
			case 2:
				$this->setPluginDesc($value);
				break;
  
			case 3:
				$this->setPluginType($value);
				break;
  
			case 4:
				$this->setPluginOrder($value);
				break;
  
			case 5:
				$this->setExclusiveType($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(PluginPeer::DATABASE_NAME);

		try {
			$con->begin();
			PluginPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(PluginPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = PluginPeer::doInsert($this, $con);
					$this->setPluginId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					PluginPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}
			if ($this->collPluginDependencysRelatedByDependsonPluginId !== null) {
				for ($i=0,$size=count($this->collPluginDependencysRelatedByDependsonPluginId); $i < $size; $i++) {
					$this->collPluginDependencysRelatedByDependsonPluginId[$i]->save($con);
				}
			  }
			if ($this->collPluginDependencysRelatedByPluginId !== null) {
				for ($i=0,$size=count($this->collPluginDependencysRelatedByPluginId); $i < $size; $i++) {
					$this->collPluginDependencysRelatedByPluginId[$i]->save($con);
				}
			  }
			if ($this->collProjectPlugins !== null) {
				for ($i=0,$size=count($this->collProjectPlugins); $i < $size; $i++) {
					$this->collProjectPlugins[$i]->save($con);
				}
			  }
			if ($this->collScmCommitFilters !== null) {
				for ($i=0,$size=count($this->collScmCommitFilters); $i < $size; $i++) {
					$this->collScmCommitFilters[$i]->save($con);
				}
			  }
			if ($this->collUserPlugins !== null) {
				for ($i=0,$size=count($this->collUserPlugins); $i < $size; $i++) {
					$this->collUserPlugins[$i]->save($con);
				}
			  }

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return PluginPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  

			if (($retval = PluginPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
			if ($this->collPluginDependencysRelatedByDependsonPluginId !== null) {
				for ($i=0,$size=count($this->collPluginDependencysRelatedByDependsonPluginId); $i < $size; $i++) {
					if (($retval = $this->collPluginDependencysRelatedByDependsonPluginId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collPluginDependencysRelatedByPluginId !== null) {
				for ($i=0,$size=count($this->collPluginDependencysRelatedByPluginId); $i < $size; $i++) {
					if (($retval = $this->collPluginDependencysRelatedByPluginId[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collProjectPlugins !== null) {
				for ($i=0,$size=count($this->collProjectPlugins); $i < $size; $i++) {
					if (($retval = $this->collProjectPlugins[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collScmCommitFilters !== null) {
				for ($i=0,$size=count($this->collScmCommitFilters); $i < $size; $i++) {
					if (($retval = $this->collScmCommitFilters[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
			if ($this->collUserPlugins !== null) {
				for ($i=0,$size=count($this->collUserPlugins); $i < $size; $i++) {
					if (($retval = $this->collUserPlugins[$i]->validate()) !== true) {
						$failureMap = array_merge($failureMap, $retval);
					}
				}
			}
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed plugin_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setPluginId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getPluginId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return Plugin Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new Plugin();
		$copyObj->setPluginName($this->plugin_name);
		$copyObj->setPluginDesc($this->plugin_desc);
		$copyObj->setPluginType($this->plugin_type);
		$copyObj->setPluginOrder($this->plugin_order);
		$copyObj->setExclusiveType($this->exclusive_type);

		if ($deepCopy) {		
			// important: setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getPluginDependencysRelatedByDependsonPluginId() as $relObj) {
				$copyObj->addPluginDependencyRelatedByDependsonPluginId($relObj->copy());
			}

			foreach($this->getPluginDependencysRelatedByPluginId() as $relObj) {
				$copyObj->addPluginDependencyRelatedByPluginId($relObj->copy());
			}

			foreach($this->getProjectPlugins() as $relObj) {
				$copyObj->addProjectPlugin($relObj->copy());
			}

			foreach($this->getScmCommitFilters() as $relObj) {
				$copyObj->addScmCommitFilter($relObj->copy());
			}

			foreach($this->getUserPlugins() as $relObj) {
				$copyObj->addUserPlugin($relObj->copy());
			}
		} // if ($deepCopy)
		
		$copyObj->setNew(true);
		
		$copyObj->setPluginId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return PluginPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new PluginPeer();
		}
		return self::$peer;
	}

}
