<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'forum' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.forum.lib.map
 */
class ForumMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.forum.lib.map.ForumMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("forum");
		$tMap->setPhpName("Forum");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("forum_forum_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("FORUM_ID", "ForumId", "int", CreoleTypes::INTEGER, true);
		$tMap->addColumn("SECTION", "Section", "string", CreoleTypes::VARCHAR, true, 20);
		$tMap->addColumn("REF_ID", "RefId", "int", CreoleTypes::INTEGER, true, null);
		$tMap->addColumn("FORUM_NAME", "ForumName", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("IS_PUBLIC", "IsPublic", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("SEND_ALL_POSTS_TO", "SendAllPostsTo", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("THREAD_COUNT", "ThreadCount", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("MESSAGE_COUNT", "MessageCount", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("MOST_RECENT_DATE", "MostRecentDate", "int", CreoleTypes::TIMESTAMP, false, null);
		$tMap->addColumn("MODERATION_LEVEL", "ModerationLevel", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("SHOW_ASSOCIATIONS_TAB", "ShowAssociationsTab", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SHOW_TAGS_TAB", "ShowTagsTab", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
