<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2007-08-02
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/scm/lib/om/BaseScmCommitFilter.php';
require_once("exceptions/PermissionDeniedException.php");
require_once("GFPermission.interface.php");
require_once("plugin/ActionManager.php");

/** 
 * The skeleton for this class was autogenerated by Propel  * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.scm.lib 
 */
class ScmCommitFilter extends BaseScmCommitFilter implements GFPermission {

	/**
	 * isPublic - true/false
	 * @return boolean
	 */
	/*function isPublic() {
		return $this->getIsPublic();
	}*/

	/**
	 * Specifies if the current user can create an entry in the database for this object
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanCreate() {
		if ($this->userIsAdmin()) {
			return true;
		}
		/*if ($this->isPublic()) {
			return true;
		}*/
		/*
		//requires manual customization
		$perm = $this->getProject()->getPermission();
		if ($perm->check(self::SECTION, SELF::CREATE)) {
			return true;
		}
		*/
		return false;
	}

	/**
	 * If this person is an admin for this object
	 * @return boolean
	 */
	private function userIsAdmin() {
		if (Session::getSession()->isSiteAdmin()) {
			return true;
		}
		
	}

	/**
	 * Specifies if the current user can update this object's entry in the database
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanUpdate() {
		return $this->userIsAdmin();
	}
	
	/**
	 * Specifies if the current user can delete this object's entry from the database
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanDelete() {
		return $this->userIsAdmin();
	}

	/**
	 * Specifies if the current user has permissions to access this object
	 *
	 * @return bool
	 * @todo Program the logic
	 */
	public function userCanRead() {
		return true;
	}

	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see ScmCommitFilter::setDeleted()
	 * @see ScmCommitFilter::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->userCanDelete()) {
			throw new PermissionDeniedException("Could not delete ScmCommitFilter object: permission denied");
		}
		ActionManager::notify("SCM_COMMIT_FILTER_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		if ($this->isNew() && !$this->userCanCreate()) {
			throw new PermissionDeniedException("Could not create ScmCommitFilter object: permission denied");
		} else if (!$this->userCanUpdate()) {
			throw new PermissionDeniedException("Could not update ScmCommitFilter object: permission denied");
		}
		
		$errors = array();
		
		if (is_null($this->filter_description) || strlen($this->filter_description) < 5) {
			$errors['filter_description'] = Language::getSessText('ScmCommitFilter.FilterDescriptionTooShort');
		}
		if (is_null($this->filter_string) || strlen($this->filter_string) < 5) {
			$errors['filter_string'] = Language::getSessText('ScmCommitFilter.FilterStringTooShort');
		}
		
		if (count($errors) > 0) {
			throw new InvalidDataException($errors);
		}
		
		parent::save($con);
		ActionManager::notify("SCM_COMMIT_FILTER_SAVE", $this);
	}


}
?>