<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists ScmServer
//
require_once('plugins/scm/lib/ScmServerPeer.php');
require_once('plugins/scm/lib/ScmServer.php');
require_once('plugins/scm/lib/ProjectScmPeer.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/templates/SiteAdminTemplate.php');
$theme = new SiteAdminTemplate();

$params = array(
		'selectedtoptab' => 'admin',
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('ScmServer.BrowsePageTitle')
		);
$theme->header($params);


// Retrieve the objects array
$crit = new Criteria();
$crit->addAscendingOrderByColumn(ScmServerPeer::SCM_TYPE);
$crit->addAscendingOrderByColumn(ScmServerPeer::HOSTNAME);
$arr = ScmServerPeer::doSelect($crit);

$theader = array();

$theader[] = $Lang->getText('ScmServer.ScmTypeName');
$theader[] = $Lang->getText('ScmServer.HostnameName');
$theader[] = $Lang->getText('Edit');
$theader[] = $Lang->getText('Delete');

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow('<span class="nonefound">'.$Lang->getText('ScmServer.NoneFound').'</span>');
} else {
	foreach ($arr as $item) {
		$trow = array();
		$trow[]=$item->getScmType();
		$trow[]=$item->getHostname();
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmServerEdit').'&amp;id='.$item->getID() .'">'. $Lang->getText('Edit') .'</a>';
		
		// See if there are projects using this server
		$c = new Criteria();
		$c->add(ProjectScmPeer::SCM_SERVER_ID, $item->getScmServerId());
		$n = ProjectScmPeer::doCount($c);
		if ($n > 0) {
			$trow[] = $Lang->getText('ScmServer.CantDelete');
		} else {
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmServerDelete').'&amp;id='.$item->getID() .'">'. $Lang->getText('Delete') .'</a>';
		}

		echo $theme->tableRow($trow);
	}
}

echo $theme->tableBottom(array('<a href="'. GFUrl::getUrl()->currentBaseUrl('ScmServerAdd').'&amp;id='.$item->getID() .'">'. $Lang->getText('ScmServer.AddNew') .'</a>'));

$theme->footer($params);

?>