<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code edits a ScmModule and saves it to the 
// database
//
require_once('plugins/scm/lib/ProjectScm.php');
require_once('Validator.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}

$ProjectScm = ProjectScmPeer::retrieveByPk($project->getProjectId());

if (is_null($ProjectScm)) {
	throw new PermissionDeniedException();
}

if (isset($_POST['reject'])) {
	GFUrl::redirect(GFUrl::getUrl()->currentBaseUrl('index'));
}

try {
	$controlled = ($_POST['controlled']) ? true : false;
	$ProjectScm->setControlled($controlled);
	
	if (!$controlled) {
		$ProjectScm->setHostname(Validator::sanitizeString($_POST['hostname']));
		$ProjectScm->setExternalBrowseUrl(Validator::sanitizeString($_POST['external_browse_url']));
	}
	
	$ProjectScm->save();
	GFUrl::redirect(GFUrl::getUrl()->currentBaseUrl('index', array('feedback' => Language::getSessText('ProjectScm.ChangesSaved'))));
} catch (InvalidDataException $ex) {
	$errors = $ex->getErrors();		// attach object errors to validation errors
	$params['feedback'] = '* '.implode('<br />* ', $errors);
	include('ScmSetControlled.php');
}


?>