<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Tim Perdue tim@gforge.org
 * @date 2005-11-11
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once 'plugins/tracker/lib/om/BaseTrackerItemRelation.php';
require_once("plugin/ActionManager.php");
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('core/UserPeer.php');

/** 
 * The skeleton for this class was autogenerated by Propel  on:
 *
 * [Wed Nov 16 20:42:33 2005]
 *
 * You should add additional methods to this class to meet the
 * application requirements.  This class will only be generated as
 * long as it does not already exist in the output directory.
 *
 * @package plugins.tracker.lib 
 */
class TrackerItemRelation extends BaseTrackerItemRelation {
	// Possible values for the "link type" field (used in MS Project plugin)
	const LINK_TYPE_FINISH_START = 'FS';
	const LINK_TYPE_FINISH_FINISH = 'FF';
	const LINK_TYPE_START_FINISH = 'SF';
	const LINK_TYPE_START_START = 'SS';
	
	/**
	 * Removes this object from datastore and sets delete attribute. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see TrackerItemRelation::setDeleted()
	 * @see TrackerItemRelation::isDeleted()
	 */
	function delete($con = null) {
		if (!$this->getTrackerItemRelatedByTrackerItemId()->userCanUpdate()) {
			throw new PermissionDeniedException();
		}
/*
		if (!$this->isNew()) { // maybe we deleted an object without storing it first, we wont audit that
			// we are just auditing the related tracker item id change
			$user_id = TrackerItemPeer::retrieveByPk($this->getTrackerItemId())->getUser()->getUserId();
			$section = TrackerItem::TRACKER_ITEM_SECTION;
			$ref_id = $this->getTrackerItemId();
			$field_name = substr(strtolower(substr(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID,strlen(TrackerItemRelationPeer::TABLE_NAME)+1)),0,20); // since were getting things like Tablename.field_name, we just want to store the field name
			$new_value = null;
			$old_value = $this->getByName(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID);
			$Audit = new AuditTrail();
			// set the audit object and save it to DB
			$Audit->setOldValue($old_value);
			$Audit->setNewValue($new_value);
			$Audit->setRefId($ref_id);
			$Audit->setSection($section);
			$Audit->setUserId($user_id);
			$Audit->setFieldName($field_name);
			$Audit->save();
		}		
*/
		ActionManager::notify("TRACKER_ITEM_RELATION_DELETE", $this);
		parent::delete($con);		
	}

	/**
	 * Stores the object in the database using the Propel methods. Informs the plugin manager.
	 * This method was added by propel_customizer.php.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	function save($con = null) {
		if ($this->getTrackerItemRelatedByTrackerItemId()->isNew()) {
			if (!$this->getTrackerItemRelatedByTrackerItemId()->userCanCreate()) {
				throw new PermissionDeniedException();
			}
		} else {
			if (!$this->getTrackerItemRelatedByTrackerItemId()->userCanUpdate()) {
				throw new PermissionDeniedException();
			}
		}
/*		//  only audit on new objects (we wont be updating this object but deleting/creating new one)
		if ((!TrackerItemPeer::retrieveByPk($this->getTrackerItemId())->isNew() && ($this->isNew()))) { // only audit if the objects Tracker Item is not new (adding new relation)
			// we are just auditing the related tracker item id change
			$user_id = TrackerItemPeer::retrieveByPk($this->getTrackerItemId())->getUser()->getUserId();
			$section = TrackerItem::TRACKER_ITEM_SECTION;
			$ref_id = $this->getTrackerItemId();
			$field_name = substr(strtolower(substr(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID,strlen(TrackerItemRelationPeer::TABLE_NAME)+1)),0,20); // since were getting things like Tablename.field_name, we just want to store the field name
			$old_value = null;
			$new_value = $this->getByName(TrackerItemRelationPeer::RELATED_TRACKER_ITEM_ID);
			$Audit = new AuditTrail();
			// set the audit object and save it to DB
			$Audit->setOldValue($old_value);
			$Audit->setNewValue($new_value);
			$Audit->setRefId($ref_id);
			$Audit->setSection($section);
			$Audit->setUserId($user_id);
			$Audit->setFieldName($field_name);
			$Audit->save();
		}
*/
		parent::save($con);
		ActionManager::notify("TRACKER_ITEM_RELATION_SAVE", $this);
	}
	
}
?>