<?php
require_once 'propel/map/MapBuilder.php';
include_once 'creole/CreoleTypes.php';

/**
 * This class adds structure of 'tracker' table to 'gf5' DatabaseMap object.
 *
 * These statically-built map classes are used by Propel to do runtime db structure discovery.
 * For example, the createSelectSql() method checks the type of a given column used in an 
 * ORDER BY clause to know whether it needs to apply SQL to make the ORDER BY case-insensitive 
 * (i.e. if it's a text column type).
 *
 * @see BasePeer
 * @see DatabaseMap
 * @package plugins.tracker.lib.map
 */
class TrackerMapBuilder implements MapBuilder {

    /**
     * The name of this class
     */
    const CLASS_NAME = "plugins.tracker.lib.map.TrackerMapBuilder";
	
    /**
     * The database map.
     */
    private $dbMap = null;

    /**
     * Tells us if this DatabaseMapBuilder is built so that we
     * don't have to re-build it every time.
     *
     * @return true if this DatabaseMapBuilder is built
     */
    public function isBuilt()
    {
        return ($this->dbMap !== null);
    }

    /**
     * Gets the databasemap this map builder built.
     *
     * @return the databasemap
     */
    public function getDatabaseMap()
    {
        return $this->dbMap;
    }

    /**
     * The doBuild() method builds the DatabaseMap
     *
	 * @return void
     * @throws PropelException
     */
    public function doBuild()
    {
		$this->dbMap = Propel::getDatabaseMap("gf5");
		
		$tMap = $this->dbMap->addTable("tracker");
		$tMap->setPhpName("Tracker");
		
         
		$tMap->setUseIdGenerator(true);
		 
						
		 
		$tMap->setPrimaryKeyMethodInfo("tracker_tracker_id_seq");
		 
		
		// Add columns to map
		$tMap->addPrimaryKey("TRACKER_ID", "TrackerId", "int", CreoleTypes::INTEGER, true);
		$tMap->addForeignKey("PROJECT_ID", "ProjectId", "int", CreoleTypes::INTEGER, "project" , "PROJECT_ID", true);
		$tMap->addColumn("TRACKER_NAME", "TrackerName", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("DESCRIPTION", "Description", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("IS_PUBLIC", "IsPublic", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("RESTRICT_BROWSE", "RestrictBrowse", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("EMAIL_ALL_UPDATES", "EmailAllUpdates", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("EMAIL_ADDRESS", "EmailAddress", "string", CreoleTypes::VARCHAR, true, null);
		$tMap->addColumn("DUE_PERIOD", "DuePeriod", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("SUBMIT_INSTRUCTIONS", "SubmitInstructions", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("BROWSE_INSTRUCTIONS", "BrowseInstructions", "string", CreoleTypes::VARCHAR, false, null);
		$tMap->addColumn("DATATYPE", "Datatype", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("ITEM_TOTAL", "ItemTotal", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("OPEN_COUNT", "OpenCount", "int", CreoleTypes::INTEGER, false, null);
		$tMap->addColumn("SHOW_DEPENDENCIES_TAB", "ShowDependenciesTab", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SHOW_DUPLICATES_TAB", "ShowDuplicatesTab", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SHOW_ASSOCIATIONS_TAB", "ShowAssociationsTab", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SHOW_TIME_TRACKING_TAB", "ShowTimeTrackingTab", "boolean", CreoleTypes::BOOLEAN, false, null);
		$tMap->addColumn("SHOW_TAGS_TAB", "ShowTagsTab", "boolean", CreoleTypes::BOOLEAN, false, null);
				
    }
}
