<?php 

require_once 'propel/om/BaseObject.php';

 
require_once 'propel/om/Persistent.php';

 

include_once 'propel/util/Criteria.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraField.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';
 

// (on-demand) include_once 'plugins/tracker/lib/TrackerItem.php';
// (on-demand) include_once 'plugins/tracker/lib/TrackerItemPeer.php';

include_once 'plugins/tracker/lib/TrackerExtraFieldDataPeer.php';

/**
 * Base class that represents a row from the 'tracker_extra_field_data' table.
 *
 *  
 *
 * You should not use this class directly.  It should not even be
 * extended; all references should be to TrackerExtraFieldData class. 
 * 
 * @package plugins.tracker.lib 
 */
abstract class BaseTrackerExtraFieldData extends BaseObject implements Persistent {
	
	/** 
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var TrackerExtraFieldDataPeer
	 */
	protected static $peer;

	/**
	 * The value for the tracker_extra_field_data_id field.
	 * @var int	  
	 */
	protected $tracker_extra_field_data_id;	

	/**
	 * The value for the tracker_item_id field.
	 * @var int	  
	 */
	protected $tracker_item_id;	

	/**
	 * The value for the field_data field.
	 * @var string	  
	 */
	protected $field_data;	

	/**
	 * The value for the tracker_extra_field_id field.
	 * @var int	  
	 */
	protected $tracker_extra_field_id;	
  
	/**
	 * Get the TrackerExtraFieldDataId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerExtraFieldDataId()
	{
		return $this->tracker_extra_field_data_id;
	}


	/**
	 * Set the value of `tracker_extra_field_data_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 *  
	 */
	public function setTrackerExtraFieldDataId($v)
	{
		if ($this->tracker_extra_field_data_id !== $v) {
			$this->tracker_extra_field_data_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID;
		}
				
	}

  
	/**
	 * Get the TrackerItemId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerItemId()
	{
		return $this->tracker_item_id;
	}


	/**
	 * Set the value of `tracker_item_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerItemId($v)
	{
		if ($this->tracker_item_id !== $v) {
			$this->tracker_item_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldDataPeer::TRACKER_ITEM_ID;
		}
			
		if ($this->aTrackerItem !== null && $this->aTrackerItem->getTrackerItemId() !== $v) {
			$this->aTrackerItem = null;
		}
			
	}

  
	/**
	 * Get the FieldData column value.
	 *  
	 * @return string	  
	 */
	public function getFieldData()
	{
		return $this->field_data;
	}


	/**
	 * Set the value of `field_data` column.	  
	 *  
	 * @param string $v new value
	 * @return void
	 *  
	 */
	public function setFieldData($v)
	{
		if ($this->field_data !== $v) {
			$this->field_data = $v;
			$this->modifiedColumns[] = TrackerExtraFieldDataPeer::FIELD_DATA;
		}
				
	}

  
	/**
	 * Get the TrackerExtraFieldId column value.
	 *  
	 * @return int	  
	 */
	public function getTrackerExtraFieldId()
	{
		return $this->tracker_extra_field_id;
	}


	/**
	 * Set the value of `tracker_extra_field_id` column.	  
	 *  
	 * @param int $v new value
	 * @return void
	 * @throws PropelException 
	 */
	public function setTrackerExtraFieldId($v)
	{
		if ($this->tracker_extra_field_id !== $v) {
			$this->tracker_extra_field_id = $v;
			$this->modifiedColumns[] = TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID;
		}
			
		if ($this->aTrackerExtraField !== null && $this->aTrackerExtraField->getTrackerExtraFieldId() !== $v) {
			$this->aTrackerExtraField = null;
		}
			
	}


	
	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return void
	 * @throws PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {
			$this->tracker_extra_field_data_id = $rs->getInt($startcol + 0);					
			$this->tracker_item_id = $rs->getInt($startcol + 1);					
			$this->field_data = $rs->getString($startcol + 2);					
			$this->tracker_extra_field_id = $rs->getInt($startcol + 3);					
			 
			$this->resetModified();
			$this->setNew(false);
		
		} catch (Exception $e) {
			throw new PropelException("Error populating TrackerExtraFieldData object", $e);
		}		
	
	}
	
	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 * 
	 * @return Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{		
		$criteria = new Criteria(TrackerExtraFieldDataPeer::DATABASE_NAME);
		$criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID, $this->tracker_extra_field_data_id);
		return $criteria;			
	}
	
	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{		
		$criteria = new Criteria(TrackerExtraFieldDataPeer::DATABASE_NAME);
		if ($this->isColumnModified(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID)) $criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID, $this->tracker_extra_field_data_id);
		if ($this->isColumnModified(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID)) $criteria->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $this->tracker_item_id);
		if ($this->isColumnModified(TrackerExtraFieldDataPeer::FIELD_DATA)) $criteria->add(TrackerExtraFieldDataPeer::FIELD_DATA, $this->field_data);
		if ($this->isColumnModified(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID)) $criteria->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $this->tracker_extra_field_id);
		return $criteria;			
	}
	
	

	/**
	 * @var TrackerExtraField	  
	 */
	protected $aTrackerExtraField;

	/**
	 * Declares an association between this object and a TrackerExtraField object
	 *
	 * @param TrackerExtraField $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraField($v)
	{
			
		if ($v === null) {
			$this->setTrackerExtraFieldId(NULL);
		} else {
			$this->setTrackerExtraFieldId($v->getTrackerExtraFieldId());
		}
   
		$this->aTrackerExtraField = $v;
	}


	/**
	 * Get the associated TrackerExtraField object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerExtraField The associated TrackerExtraField object.
	 * @throws PropelException
	 */
	public function getTrackerExtraField($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerExtraFieldPeer.php';

		if ($this->aTrackerExtraField === null && ($this->tracker_extra_field_id !== null)) {
	
			$this->aTrackerExtraField = TrackerExtraFieldPeer::retrieveByPK($this->tracker_extra_field_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerExtraFieldPeer::retrieveByPK($this->tracker_extra_field_id, $con);
			   $obj->addTrackerExtraFieldDatas($this);
			 */
		}
		return $this->aTrackerExtraField;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerExtraFieldKey($key)
	{

		$this->setTrackerExtraFieldId( (int) $key);			
		
	}

	/**
	 * @var TrackerItem	  
	 */
	protected $aTrackerItem;

	/**
	 * Declares an association between this object and a TrackerItem object
	 *
	 * @param TrackerItem $v
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItem($v)
	{
			
		if ($v === null) {
			$this->setTrackerItemId(NULL);
		} else {
			$this->setTrackerItemId($v->getTrackerItemId());
		}
   
		$this->aTrackerItem = $v;
	}


	/**
	 * Get the associated TrackerItem object
	 *
	 * @param Connection Optional Connection object.
	 * @return TrackerItem The associated TrackerItem object.
	 * @throws PropelException
	 */
	public function getTrackerItem($con = null)
	{
		// include the Peer class
		include_once 'plugins/tracker/lib/TrackerItemPeer.php';

		if ($this->aTrackerItem === null && ($this->tracker_item_id !== null)) {
	
			$this->aTrackerItem = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
	
			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = TrackerItemPeer::retrieveByPK($this->tracker_item_id, $con);
			   $obj->addTrackerExtraFieldDatas($this);
			 */
		}
		return $this->aTrackerItem;
	}

	/**
	 * Provides convenient way to set a relationship based on a
	 * key.  e.g.
	 * <code>$bar->setFooKey($foo->getPrimaryKey())</code>
	 *
 
	 * @return void
	 * @throws PropelException
	 */
	public function setTrackerItemKey($key)
	{

		$this->setTrackerItemId( (int) $key);			
		
	}

	private $fieldNames;

	/**
	 * Generate a list of field names.
	 *
	 * @return array A list of field names
	 */
	public function getFieldNames()
	{
		if ($this->fieldNames === null) {
			$this->fieldNames = array("tracker_extra_field_data_id", "tracker_item_id", "field_data", "tracker_extra_field_id", );
		}
		return $this->fieldNames;
	}
	
	/**
	 * Retrieves a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @return mixed Value of field.
	 */
	public function getByName($name)
	{
		switch($name) {
	  
			case TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID:
				return $this->getTrackerExtraFieldDataId();
				break;
		  
			case TrackerExtraFieldDataPeer::TRACKER_ITEM_ID:
				return $this->getTrackerItemId();
				break;
		  
			case TrackerExtraFieldDataPeer::FIELD_DATA:
				return $this->getFieldData();
				break;
		  
			case TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID:
				return $this->getTrackerExtraFieldId();
				break;
	  
			default:
				return null;
				
		} // switch()
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema. 
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @return mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
  
			case 0:
				return $this->getTrackerExtraFieldDataId();
				break;
  
			case 1:
				return $this->getTrackerItemId();
				break;
  
			case 2:
				return $this->getFieldData();
				break;
  
			case 3:
				return $this->getTrackerExtraFieldId();
				break;
			default:
				return null;
		} // switch()
	}



	
	/**
	 * Convenience method to populate the object using an array.
	 * This is particularly useful when populating an object from one of the request arrays (e.g. $_POST).  This method
	 * goest through the column (peer) names, checking to see whether a matching key exists in populated array. If
	 * so the setByName() method is called for that column.
	 * @param array $arr An array where keys are column names.
	 * @return void
	 */
	public function populateFromArray($arr)
	{
  
		if (array_key_exists(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID, $arr)) $this->setTrackerExtraFieldDataId($arr[TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID]);
  
		if (array_key_exists(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID, $arr)) $this->setTrackerItemId($arr[TrackerExtraFieldDataPeer::TRACKER_ITEM_ID]);
  
		if (array_key_exists(TrackerExtraFieldDataPeer::FIELD_DATA, $arr)) $this->setFieldData($arr[TrackerExtraFieldDataPeer::FIELD_DATA]);
  
		if (array_key_exists(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $arr)) $this->setTrackerExtraFieldId($arr[TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID]);
 
	}
	
	/**
	 * Sets a field from the object by name passed in as a string.
	 * The string must be one of the static strings defined in this Class' Peer.
	 *
	 * @param string $name peer name
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByName($name, $value)
	{
		switch($name) {
	  
			case TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_DATA_ID:
				$this->setTrackerExtraFieldDataId($value);
				break;
	  
			case TrackerExtraFieldDataPeer::TRACKER_ITEM_ID:
				$this->setTrackerItemId($value);
				break;
	  
			case TrackerExtraFieldDataPeer::FIELD_DATA:
				$this->setFieldData($value);
				break;
	  
			case TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID:
				$this->setTrackerExtraFieldId($value);
				break;
				  
		} // switch()
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param int $pos position in xml schema
	 * @param mixed $value field value
	 * @return void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
  
			case 0:
				$this->setTrackerExtraFieldDataId($value);
				break;
  
			case 1:
				$this->setTrackerItemId($value);
				break;
  
			case 2:
				$this->setFieldData($value);
				break;
  
			case 3:
				$this->setTrackerExtraFieldId($value);
				break;
		} // switch()
	}


 
	/**
	 * Removes this object from datastore and sets delete attribute.
	 * 
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 * @see BaseObject::setDeleted()
	 * @see BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{	
		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerExtraFieldDataPeer::DATABASE_NAME);

		try {
			$con->begin();
			TrackerExtraFieldDataPeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
	

	/**
	 * flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	private $alreadyInSave = false;

	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
	public function save($con = null)
	{
		if ($this->isDeleted()) {
		//	throw new PropelException("You cannot save an object that has been deleted.");
			return;
		}
		
		if ($con === null)
			$con = Propel::getConnection(TrackerExtraFieldDataPeer::DATABASE_NAME);

		try {
			$con->begin();
			$this->doSave($con);			
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}
  
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.
	 *
	 * @param Connection $con
	 * @return void
	 * @throws PropelException
	 */
		protected function doSave($con)	{ 
		
	 
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;

			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
 
			if ($this->aTrackerExtraField !== null) {
				if ($this->aTrackerExtraField->isModified()) $this->aTrackerExtraField->save($con);
				$this->setTrackerExtraField($this->aTrackerExtraField);
			}
 
			if ($this->aTrackerItem !== null) {
				if ($this->aTrackerItem->isModified()) $this->aTrackerItem->save($con);
				$this->setTrackerItem($this->aTrackerItem);
			}

			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = TrackerExtraFieldDataPeer::doInsert($this, $con);
					$this->setTrackerExtraFieldDataId( $pk );  //[IMV] update autoincrement primary key
					$this->setNew(false);
				} else {
					TrackerExtraFieldDataPeer::doUpdate($this, $con);
				}			
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			$this->alreadyInSave = false;
		}
	}

	/**
	 * Validates the objects modified field values.
	 * This includes all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param mixed $columns Column name or an array of column names.
	 *
	 * @return mixed <code>true</code> if all columns pass validation
	 *			  or an array of <code>ValidationFailed</code> objects for columns that fail.
	 */
	public function validate($columns = null)
	{
	  if ($columns)
	  {
		return TrackerExtraFieldDataPeer::doValidate($this, $columns);
	  }

		return $this->doValidate();
	}

	/**
	 * flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var boolean
	 */
	protected $alreadyInValidation = false;
  
	/**
	 * This function performs the validation work for complex object models.
	 * 
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @return mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate()
	{
		if (! $this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;
	  
			$failureMap = array();	  
	  
			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.
			if ($this->aTrackerExtraField !== null) {
				if (($retval = $this->aTrackerExtraField->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}
			if ($this->aTrackerItem !== null) {
				if (($retval = $this->aTrackerItem->validate()) !== true) {
					$failureMap = array_merge($failureMap, $retval);
				}
			}

			if (($retval = TrackerExtraFieldDataPeer::doValidate($this)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}
	  
	  
			$this->alreadyInValidation = false;
		}
	
		return (!empty($failureMap) ? $failureMap : true);
	}
  

	/**
	 * Set the PrimaryKey.
	 *
	 * @param mixed tracker_extra_field_data_id Primary key.
	 * @return void
	 * @throws PropelException	 */
	public function setPrimaryKey($key) 
	{		
		$this->setTrackerExtraFieldDataId($key);
	}
	

	/**
	 * Returns an id that differentiates this object from others
	 * of its class.
	 * @return int 
	 */
	public function getPrimaryKey()
	{

		return $this->getTrackerExtraFieldDataId();

	}

	
	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *  
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 *  
	 * @return TrackerExtraFieldData Clone of current object.
	 * @throws PropelException
	 */
	public function copy($deepCopy = false) 
	{
		$copyObj = new TrackerExtraFieldData();
		$copyObj->setTrackerItemId($this->tracker_item_id);
		$copyObj->setFieldData($this->field_data);
		$copyObj->setTrackerExtraFieldId($this->tracker_extra_field_id);
		
		$copyObj->setNew(true);
		
		$copyObj->setTrackerExtraFieldDataId(NULL); // this is a pkey column, so set to default value

		return $copyObj;
	}
		

	/**
	 * returns a peer instance associated with this om.  Since Peer classes	
	 * are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 * @return TrackerExtraFieldDataPeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new TrackerExtraFieldDataPeer();
		}
		return self::$peer;
	}

}
