<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerItemRelation
//
require_once('plugins/tracker/lib/TrackerItemDuplicatePeer.php');
require_once('plugins/tracker/lib/TrackerItemDuplicate.php');
require_once('exceptions/PermissionDeniedException.php');

if ($IS_TECH) {
	echo '<strong>'.$Lang->getText('TrackerItem.CommaSepListOfDups').'</strong><br />';
	echo '<input type="text" name="duplicate_items" size="60" maxlength="120">&nbsp;&nbsp;
	      <a href="javascript:void(0);" onclick="popup(\''.GFUrl::getUrl()->projectURL($Project, 'TrackerItemList', 'tracker', '/popups', array('tracker_id' =>$TrackerItem->getTrackerId(),'field'=>'duplicate_items')).'\', \'300\', \'250\');">'.$Lang->getText('TrackerItemDuplicatePopup.Link').'</a><br />';
}

$tis=$TrackerItem->getTrackerItemDuplicatesRelatedByTrackerItemIdJoinTrackerItemRelatedByDuplicateOfTrackerItemId();

$theader=array();
$theader[] = $Lang->getText('TrackerItem.TrackerItemIdName');
$theader[] = $Lang->getText('TrackerItem.SummaryName');
$theader[] = $Lang->getText('TrackerItemField.Percent');
$theader[] = $Lang->getText('TrackerExtraField.FieldType7');
$theader[] = $Lang->getText('Delete');
//	$theader[] = $Lang->getText('TrackerItem.Su');

echo '<br /><strong>'.$Lang->getText('TrackerItem.HasDuplicates').'</strong><br />';
echo $theme->tableTop($theader);
if (count($tis) < 1) {
	echo $theme->tableFullRow($Lang->getText('TrackerItemDuplicate.NoneFound'));
} else {
	foreach ($tis as $ti) {
		$duplicated_tracker_item_id =  $ti->getDuplicateOfTrackerItemId();
		$duplicated_tracker_item	= TrackerItemPeer::retrieveByPk($duplicated_tracker_item_id);
		$tef = $duplicated_tracker_item->getTracker()->getTrackerExtraFields();

		$percentcomplete_field = null;
		foreach ($tef as $tracker_extra_field) {
			if ($tracker_extra_field->getAlias() == 'percentcomplete') {
				$percentcomplete_field = $tracker_extra_field;
			}
		}
		
		if (is_object($percentcomplete_field)) {
			$tracker_extra_field_id = $percentcomplete_field->getTrackerExtraFieldId();
			
			$c = new Criteria();
			$c->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $tracker_extra_field_id);
			$c->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID,  $duplicated_tracker_item_id);
			$percentagecomplete_field = TrackerExtraFieldDataPeer::doSelectOne($c);
			$percentagecomplete_data = (!is_null($percentagecomplete_field) ? $percentagecomplete_field->getFieldData() : 0);
		} else {
			$percentagecomplete_data = 0;
		}

		$trow=array();
		$trow[]=$duplicated_tracker_item->getTrackerItemId();
		$trow[]=$duplicated_tracker_item->getTrackerItemLink(); //Summary();
		$trow[]=$percentagecomplete_data;
		$trow[]=($duplicated_tracker_item->getStatusId() == 0) ? 'Closed' : 'Open';
		$trow[]='<input type="checkbox" name="del_duplicate[]" value="'.$duplicated_tracker_item->getTrackerItemId().'" />';
		echo $theme->tableRow($trow);
	}
}
echo $theme->tableBottom();


//This is duplicate of other items

$tis=$TrackerItem->getTrackerItemDuplicatesRelatedByDuplicateOfTrackerItemIdJoinTrackerItemRelatedByTrackerItemId();
$theader=array();
$theader[] = $Lang->getText('TrackerItem.TrackerItemIdName');
$theader[] = $Lang->getText('TrackerItem.SummaryName');
$theader[] = $Lang->getText('TrackerItemField.Percent');
$theader[] = $Lang->getText('TrackerExtraField.FieldType7');

echo '<br /><strong>'.$Lang->getText('TrackerItem.DuplicateOf').'</strong><br />';
echo $theme->tableTop($theader);
if (count($tis) < 1) {
	echo $theme->tableFullRow($Lang->getText('TrackerItemDuplicate.NoneFound'));
} else {
	foreach ($tis as $ti) {
		$tracker_item_id =  $ti->getTrackerItemId();
		$tracker_item	= TrackerItemPeer::retrieveByPk($tracker_item_id);
		$tef = $tracker_item->getTracker()->getTrackerExtraFields();

		$percentcomplete_field = '';
		foreach ($tef as $tracker_extra_field) {
			if ($tracker_extra_field->getAlias() == 'percentcomplete') {
				$percentcomplete_field = $tracker_extra_field;
			}
		}

		if (is_object($percentcomplete_field)) {
			$tracker_extra_field_id = $percentcomplete_field->getTrackerExtraFieldId();

			$c = new Criteria();
			$c->add(TrackerExtraFieldDataPeer::TRACKER_EXTRA_FIELD_ID, $tracker_extra_field_id);
			$c->add(TrackerExtraFieldDataPeer::TRACKER_ITEM_ID,  $tracker_item_id);
			$percentagecomplete_field = TrackerExtraFieldDataPeer::doSelectOne($c);
			$percentagecomplete_data = (!is_null($percentagecomplete_field) ? $percentagecomplete_field->getFieldData() : 0);
		} else {
			$percentagecomplete_data = 0;
		}

		$trow=array();
		$trow[]=$tracker_item->getTrackerItemId();
		$trow[]=$tracker_item->getTrackerItemLink(); //Summary();
		$trow[]=$percentagecomplete_data;
		$trow[]=($tracker_item->getStatusId() == 0) ? 'Closed' : 'Open';
		echo $theme->tableRow($trow);
	}
}
echo $theme->tableBottom();

?>
