<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code shows a form for editing TrackerItem
//
require_once('plugins/tracker/lib/TrackerItemPeer.php');
require_once('plugins/tracker/lib/TrackerItem.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('plugins/tracker/lib/html/TrackerExtraFieldRenderer.php');
require_once('plugins/frs/lib/FrsReleasePeer.php');
require_once('plugins/frs/lib/FrsRelease.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('plugins/tracker/lib/html/TrackerTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();
$TrackerItem = TrackerItemPeer::retrieveByPk($_REQUEST['tracker_item_id']);
$start = (isset($_REQUEST['start'])) ? intval($_REQUEST['start']) : 0;

if (!is_object($TrackerItem)) {
	throw new PermissionDeniedException();
}
$Tracker=$TrackerItem->getTracker();
if (!is_object($TrackerItem) || !$TrackerItem->userCanRead()) {
	throw new PermissionDeniedException();
}

// Make sure the tracker belongs to the current project
if ($Tracker->getProjectId() != $Project->getProjectId()) {
	throw new PermissionDeniedException();
}

if ($session->isLoggedIn()) {
	$IS_TECH=$Project->getPermission()->check(Tracker::SECTION, $Tracker->getTrackerId(), Tracker::PERMLEVEL_TECH);
	$IS_SUBMITTER = ($session->getUser()->getUserId() == $TrackerItem->getSubmittedBy());
} else {
	$IS_TECH=false;
	$IS_SUBMITTER=false;
}

$obj = $TrackerItem;

$params = array(
		'project' => $Project,
		'tracker' => $Tracker,
		'tracker_item' => $TrackerItem,
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'action' => isset($action) ? $action : '',
		'title' => $Lang->getText('TrackerItem.EditPageTitle')
		);

$tefr = new TrackerExtraFieldRenderer($Tracker);

$start_date=((isset($_REQUEST['start_date'])) ? $_REQUEST['start_date'] : $obj->getOpenDate('M d Y'));
$end_date=((isset($_REQUEST['end_date'])) ? $_REQUEST['end_date'] : $obj->getCloseDate('M d Y'));

include('forms/TrackerItemEdit-tpl.php');

?>
