<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Tracker
//
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/Tracker.php');
require_once('plugins/tracker/lib/html/TrackerTemplate.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/ProjectTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();
if (!$Project->getPermission()->check(Tracker::SECTION,0,Tracker::PERMLEVEL_ADMIN)) {
	throw new PermissionDeniedException();
}

$params = array(
		'project' => $Project,
		'selectedbottomtab'=>'tracker',
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Tracker.BrowsePageTitle')
		);
$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker','admin').'">'.$Lang->getText('Tabs.Admin').'</a>');
$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker').'">'.$Lang->getText('Tracker.TabString').'</a>');
$theme->header($params);

// Retrieve the objects array
$crit = new Criteria();
$crit->add(TrackerPeer::PROJECT_ID, $Project->getProjectId());
$crit->addAscendingOrderByColumn(TrackerPeer::DATATYPE);
$arr = TrackerPeer::doSelect($crit);


	$theader = array();

	$theader[] = $Lang->getText('Tracker.DatatypeName');
	$theader[] = $Lang->getText('Tracker.TrackerNameName');
	$theader[] = $Lang->getText('Edit');
	$theader[] = $Lang->getText('Delete');
	//$theader[] = $Lang->getText('TrackerExtraField.Edit');
	//$theader[] = $Lang->getText('TrackerCannedResponse.Edit');

	echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('Tracker.NoneFound'));
} else {
	reset($arr);
	$ttype=array();
	foreach ($arr as $item) {
		$ttype[$item->getDataType()][]=$item;
	}

	reset($arr);
	$lasttype='-1';

	foreach ($arr as $item) {
		$trow = array();
		$tmod = array();
		if ($item->getDataType() != $lasttype) {
			$lasttype=$item->getDataType();
			$tmod[]='rowspan="'.count($ttype[$item->getDataType()]).'" bgcolor="#FFFFFF"';
			$trow[]=(($item->getDataType()==Tracker::DATATYPE_TASK) ? 'Tasks' : 'Issues');
		}
		$trow[]=$item->getTrackerName();
		$tmod[]='';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerEdit').'&amp;tracker_id='.$item->getTrackerID() .'">'. $Lang->getText('Edit') .'</a>';
		$tmod[]='';
		$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerDelete').'&amp;tracker_id='.$item->getTrackerID() .'">'. $Lang->getText('Delete') .'</a>';
		$tmod[]='';
	//	$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerExtraFieldBrowse').'&amp;tracker_id='.$item->getTrackerID() .'">'. $Lang->getText('TrackerExtraField.Edit') .'</a>';
	//	$tmod[]='';
	//	$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerCannedResponseBrowse').'&amp;tracker_id='.$item->getTrackerID() .'">'. $Lang->getText('TrackerCannedResponse.Edit') .'</a>';

		echo $theme->tableRow($trow,$tmod, false);
	}

}
	echo $theme->tableBottom(array(GFUrl::getUrl()->currentBaseUrl('TrackerAdd')=>$Lang->getText('Tracker.AddNew')));


$theme->footer($params);
?>
