<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code lists Tracker
//
require_once('plugins/tracker/lib/TrackerPeer.php');
require_once('plugins/tracker/lib/Tracker.php');
require_once('plugins/tracker/lib/html/TrackerTemplate.php');
require_once('html/Paginator.php');

$session = Session::getSession();
$Lang = $session->getLanguage();

require_once('lib/html/ProjectTemplate.php');
$theme = new TrackerTemplate();

$Project = GFUrl::getUrl()->getProject();

$params = array(
		'selectedbottomtab' => 'tracker',
		'project' => $Project,
		'action' => isset($action) ? $action : '',
		'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
		'title' => $Lang->getText('Tracker.BrowsePageTitle')
		);
$theme->addBreadCrumb('<a href="'.GFUrl::getUrl()->projectUrl($params['project'],'','tracker').'">'.$Lang->getText('Tracker.TabString').'</a>');
$theme->header($params);

//make paginator code
$total=0;
$default_sort_by=TrackerPeer::DATATYPE;

$columns = array(
TrackerPeer::DATATYPE=>$Lang->getText('Tracker.DatatypeName'),
TrackerPeer::TRACKER_NAME=>$Lang->getText('Tracker.TrackerNameName'),
TrackerPeer::DESCRIPTION=>$Lang->getText('Tracker.DescriptionName'),
TrackerPeer::ITEM_TOTAL=>$Lang->getText('Tracker.ItemTotalName'),
TrackerPeer::OPEN_COUNT=>$Lang->getText('Tracker.OpenCountName')
);


// Retrieve the objects array
$crit = new Criteria();
$crit->add(TrackerPeer::PROJECT_ID, $Project->getProjectId());
//$crit->addAscendingOrderByColumn(TrackerPeer::DATATYPE);

$total = TrackerPeer::doCount($crit);

$paginator = new Paginator('br_trackers', -1, $total, $default_sort_by, $columns);

$paginator->addPageClauses($crit);

$arr = TrackerPeer::doSelect($crit);

$sort = $paginator->getSortingOptions();
$sort_by = $sort['sort_by'];
$sort_order = $sort['order'];

$theader = $paginator->getSortableTableHeaders($theme);

echo $theme->tableTop($theader);

if (count($arr) < 1) {
	echo $theme->tableFullRow($Lang->getText('Tracker.NoneFound'));
} else {

	reset($arr);
	$ttype=array();
	foreach ($arr as $item) {
		if ($item->userCanRead()) {
			$ttype[$item->getDataType()][]=$item;
		}
	}
	$bol_accessible = false;
	reset($arr);
	$lasttype='-1';
	foreach ($arr as $item) {
		if ($item->userCanRead()) {
			$bol_accessible = true;
			$trow = array();
			$tmod = array();
			//if using non-standard sort, the grouping will not work
			if ($item->getDataType() != $lasttype || $default_sort_by != $sort_by) {
				$lasttype=$item->getDataType();
				if ($default_sort_by != $sort_by) {
					$tmod[]='rowspan="1"';
				} else {
					$tmod[]='rowspan="'.count($ttype[$item->getDataType()]).'" bgcolor="#FFFFFF"';
				}
				$trow[]=(($item->getDataType()==Tracker::DATATYPE_TASK) ? $Lang->getText('Tracker.Tasks') : $Lang->getText('Tracker.Issues'));
				$icon=(($item->getDataType()==Tracker::DATATYPE_TASK) ? 'task' : 'tracker');
			}
			$trow[]='<a href="'. GFUrl::getUrl()->currentBaseUrl('TrackerItemBrowse').'&amp;tracker_id='.$item->getTrackerID() .'"><img src="/images/'.$icon.'_icon.gif" height="16" width="16" border="0" />&nbsp;'. $item->getTrackerName().'</a>';
			$tmod[]='';
			$trow[]=$item->getDescription();
			$tmod[]='';
			$trow[]=$item->getItemTotal();
			$tmod[]='';
			$trow[]=$item->getOpenCount();
			$tmod[]='';
	
			echo $theme->tableRow($trow,$tmod, false);
		}
	}
	if ($bol_accessible == false) {
		echo $theme->tableFullRow($Lang->getText('Tracker.NoneFound'));
	}	
}

$perm = $Project->getPermission();
if ($perm->check(Tracker::SECTION, 0, Tracker::PERMLEVEL_ADMIN)) {
	$button_enabled = true;
} else {
	$button_enabled = false;
}
echo $theme->tableBottom(array(GFUrl::getURL()->projectUrl($Project,'','tracker','admin',array())=>$Lang->getText('Tracker.Manage')),array($button_enabled));

if(isset($paginator) && is_object($paginator)) {
	echo '<div class="paginator">' . $paginator->getPaginator() . '</div><br />';
}


$theme->footer($params);
?>
