<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @author		Marcelo Mottalli <marcelo@gforgegroup.com>
 * @version   $Id$
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('plugins/frs/lib/FrsProjectSetting.php');

$server->wsdl->addComplexType(
	'FrsProjectSetting',
	'complexType',
	'struct',
	'sequence',
	'',
	array(
		'project_id' => array('name'=>'project_id', 'type' => 'xsd:int'),
		'show_associations_tab' => array('name'=>'show_associations_tab', 'type' => 'xsd:boolean'),
		'show_tags_tab' => array('name'=>'show_tags_tab', 'type' => 'xsd:boolean'),
	)
);

$server->register(
	'setFrsProjectSettings',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' 	=> 'xsd:int',
		'show_associations_tab'	=> 'xsd:boolean',
		'show_tags_tab'	=> 'xsd:boolean',
	), 
	array('setFrsProjectSettings' => 'xsd:int'),
	$uri, 
	$uri.'#setFrsProjectSettings',
	'rpc',
	'encoded'
);

function setFrsProjectSettings($sessionHash, $project_id, $show_associations_tab, $show_tags_tab) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);
	
	$obj = FrsProjectSettingPeer::retrieveByPk($project_id);
	if (!$obj) {
		$obj = new FrsProjectSetting();
		$obj->setProjectId($project_id);
	}
	
	$obj->setShowAssociationsTab(Validator::sanitizeBool($show_associations_tab));
	$obj->setShowTagsTab(Validator::sanitizeBool($show_tags_tab));
	$obj->save();
	
	return 1;
}

$server->register(
	'getFrsProjectSettings',
	array(
		'sessionHash'	=> 'xsd:string',
		'project_id' 	=> 'xsd:int',
	), 
	array('getFrsProjectSettings' => 'tns:FrsProjectSetting'),
	$uri, 
	$uri.'#getFrsProjectSettings',
	'rpc',
	'encoded'
);

function getFrsProjectSettings($sessionHash, $project_id) {
	$ip = $_SERVER['REMOTE_ADDR'];
	Session::getSession()->setup($sessionHash, $ip);
	
	$obj = FrsProjectSettingPeer::retrieveByPk($project_id);
	if (!$obj) {
		return null;
	}
	
	$ret = array();
	$ret['project_id'] = $obj->getProjectId();
	$ret['show_associations_tab'] = $obj->getShowAssociationsTab();
	$ret['show_tags_tab'] = $obj->getShowTagsTab();
	
	return $ret;
}


?>
