<?php

/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version $Id$
 * @author Daniel A. Prez	daniel@gforgegroup.com
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('lib/core/UserPeer.php');
require_once('lib/core/ProjectPeer.php');
require_once('lib/core/RolePeer.php');
require_once('lib/core/UserProjectPeer.php');

if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

if (array_key_exists('user_name',$_POST)) {
	$user_name = $_POST['user_name'];
} else {
	$user_name = null;
}

if (array_key_exists('project_id',$_POST)) {
	$project_id = $_POST['project_id'];
} else {
	$project_id = null;
}

if ($user_name && $project_id) {
	$c = new Criteria();
	$c->add(UserPeer::UNIX_NAME,$user_name);
	$user = UserPeer::doSelectOne($c);
	if (is_object($user)) { // get the user, and test if it exists
		$project = ProjectPeer::retrieveByPk($project_id);
		if (is_object($project)) {
			$role = RolePeer::retrieveByPk($_POST['role']);
			if (is_object($role)) {
				$c = new Criteria();
				$c->add(UserProjectPeer::PROJECT_ID,$project->getProjectId());
				$c->add(UserProjectPeer::USER_ID,$user->getPrimaryKey());
				if (!is_object(UserProjectPeer::doSelectOne($c))) {
					$up = new UserProject();
					$up->setUser($user);
					$up->setProject($project);
					$up->setRole($role);
					$up->save();
					$feedback = Language::getSessText('ProjectAdmin.UserAdded');					
				} else {
					$feedback = Language::getSessText('Validation.UserExists');
				}
			} else {
				$feedback = Language::getSessText('Role.NotExists');
			}
		} else {
			$feedback = Language::getSessText('Project.ProjectNotExists');
		}
	} else {
		$feedback = Language::getSessText('LostPass.NotExists');
	}
} else {
	$feedback = Language::getSessText('UserAdd.MissingParams');
}

GFUrl::redirect(GFUrl::getUrl()->baseURL('userlist','','admin',array('feedback'=>$feedback,'project_id'=>$project_id)));

?>
