<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
// This code creates a new SiteAdmin and saves it to the 
// database
//
require_once('core/SiteAdmin.php');
require_once('Validator.php');
require_once('exceptions/InvalidDataException.php');
require_once('exceptions/PermissionDeniedException.php');
require_once('core/Language.php');
require_once('Validator.php');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
	throw new PermissionDeniedException();
}
if (!Session::getSession()->isSiteAdmin()) {
	throw new PermissionDeniedException();
}

if (array_key_exists('user_name',$_POST)) {
	$user_name = Validator::sanitizeString($_POST['user_name']);
} else {
	$user_name = null;
}

$Lang = Language::getSessLang();

if (empty($user_name)) {
	$feedback = $Lang->getText('SiteAdmin.EmptyUsername');
} else {
	$user = UserPeer::retrieveByUnixName($user_name);
	if (is_object($user) && !$user->getIsGroup()) {
		$user_id = $user->getUserId();
		$c = new Criteria();
		$c->add(SiteAdminPeer::USER_ID,$user_id);
		if (!is_object(SiteAdminPeer::doSelectOne($c))) {
			$SiteAdmin = new SiteAdmin();
			$SiteAdmin->setUserId($user_id);
			try {
				$SiteAdmin->save();
				$feedback = $Lang->getText('SiteAdmin.AddFeedback');
			} catch (InvalidDataException $ex) {
				$errors = array_merge($errors, $ex->getErrors());		// attach object errors to validation errors
				$feedback = '* '.implode('<br />* ', $errors);
				include('SiteAdminAdd.php');
			}
		} else {
			$feedback = $Lang->getText('SiteAdmin.Exists');
		}
	} else {
		$feedback = $Lang->getText('SiteAdmin.UserNotExists', array($user_name));
	}
}
GFUrl::redirect(GFUrl::getUrl()->currentBaseURL('SiteAdminBrowse'), array('feedback' => $feedback));
?>
