<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id: Layout.php 270 2005-12-31 03:02:47Z tperdue $
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
//
require_once('lib/core/User.php');
require_once('lib/exceptions/PermissionDeniedException.php');
require_once('lib/core/Language.php');
require_once('lib/SystemUtils.php');

$Lang = Language::getSessLang();

if (array_key_exists('sure',$_POST)) {
	$user = UserPeer::retrieveByPk($_POST['id']);
	if (is_object($user) && Session::getSession()->isSiteAdmin()) {
		if (array_key_exists('send_reject',$_POST)) {
			if (!empty($_POST['response_title']) && !empty($_POST['response_text'])) {
				// Remove the user from the database... it's assumed that the user doesn't have 
				// any activity recorded (forum messages, etc) so it's safe to do this
				$email = $user->getEmail();
				
				$user->deleteFromDB();

				$feedback = Language::getSessText('UserRejectForm.Rejected',array($user->getFullName())) . '<br />';
				$feedback .= Language::getSessText('UserRejectForm.RejectMailSent') . '<br />';
				SystemUtils::sendMail($_POST['response_title'],$_POST['response_text'], $email);
				
			} else {
				$feedback = Language::getSessText('UserRejectForm.EmptyMailInfo') . '<br />';
			}
		} else {
			$user->deleteFromDB();
			$feedback = Language::getSessText('UserRejectForm.Rejected',array($user->getFullName())) . '<br />';
		} 
		GFUrl::redirect($url->currentBaseURL('PendingUserApproval', array('feedback' => $feedback)));
	} else {
		throw new PermissionDeniedException();
	}
} else {
	GFUrl::redirect($url->currentBaseURL('PendingUserApproval'), array('feedback' => $Lang->getText('UserRejectForm.DidNotConfirm')));
}

?>
