<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino jyerfino@gforgegroup.com
 * @date
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once('html/MyTemplate.php');
require_once('lib/core/FilesystemPeer.php');
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once('lib/core/MyReportFieldFilter.php');
require_once('lib/core/MyReportFieldDisplay.php');
require_once('lib/core/MyReportFieldFilterPeer.php');
require_once('lib/core/MyReportFieldDisplayPeer.php');
require_once('lib/core/MyReportTracker.php');
require_once('lib/core/MyReportTrackerPeer.php');
require_once('lib/core/MyReportProject.php');
require_once('lib/core/MyReportProjectPeer.php');
require_once('lib/core/MyReportFieldValue.php');
require_once('lib/core/MyReportFieldValuePeer.php');


$session=Session::getSession();
if (!$session->isLoggedIn()) {
	throw new NotLoggedInException();
}
$template = new MyTemplate();
$user = Session::getSession()->getUser();

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
if(isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
	// Fetch report data
	if($report_id != 0) {
		$report = MyReportPeer::retrieveByPK($report_id);
		if(!is_object($report)) {
			throw new InvalidDataException();
		}
		// Check if the user can view the report
		if (!$report->userCanRead()) {
			throw new PermissionDeniedException();
		}
	}
	else {
		throw new InvalidDataException();
	}
}
else {
	throw new InvalidDataException();
}
$Lang = $session->getLanguage();

if(isset($_REQUEST['feedback'])) $feedback = $_REQUEST['feedback'];
$params = array(
	'title' => Language::getSessText('Report.ViewReport'),
	'feedback' => isset($_REQUEST['feedback']) ? $_REQUEST['feedback'] : (isset($feedback) ? $feedback : ''),
	'action' => isset($action) ? $action : '',
	'selectedbottomtab' => 'myreports',
	'user' => $user
	);
$params['theme'] = $template;
	
$template->header($params);

$tracker_item_ids = $report->getTrackerItemIds();
$theader = array();
$theader[] = Language::getSessText('Report.TrackerItemId');

echo "<table width='100%'><tr>";
echo "<td width='50%' align='center'><img src='/gf/my/reports/graphs/?action=ReportGraphByProject&report_id=$report_id'/></td>";
echo "<td width='50%' align='center'><img src='/gf/my/reports/graphs/?action=ReportGraphByAssignee&report_id=$report_id'/></td>";
echo "</tr></table><br>";

if(!is_array($tracker_item_ids) || count($tracker_item_ids)==0) {
	echo $theme->tableTop($theader);
	echo $theme->tableFullRow(Language::getSessText('Report.NoMatchesFound'));
}
else {
	//$tracker_items = TrackerItemPeer::retrieveByPKs($tracker_item_ids);
	$display_data = $report->getDisplayData($tracker_item_ids);
	
	$crit = new Criteria();
	$crit->add(MyReportFieldDisplayPeer::MY_REPORT_ID, $report_id);
	$crit->addAscendingOrderByColumn(MyReportFieldDisplayPeer::COLUMN_ORDER);
	$display_field_names = MyReportFieldDisplayPeer::doSelect($crit);
	$headers = array();
	foreach($display_field_names as $display_field_name) {
		switch($display_field_name->getType()) {
			case MyReport::FIELDTYPE_ASSIGNEES:
				$theader[] = Language::getSessText('TrackerItem.AssignedTo');
				break;
			case MyReport::FIELDTYPE_SUMMARY:
				$theader[] = Language::getSessText('TrackerItem.SummaryName');
				break;
			case MyReport::FIELDTYPE_DETAILS:
				$theader[] = Language::getSessText('TrackerItem.DetailsName');
				break;
			case MyReport::FIELDTYPE_PRIORITY:
				$theader[] = Language::getSessText('TrackerItem.PriorityName');
				break;
			case MyReport::FIELDTYPE_OPENDATE:
				$theader[] = Language::getSessText('TrackerItem.OpenDateName');
				break;
			case MyReport::FIELDTYPE_CLOSEDATE:
				$theader[] = Language::getSessText('TrackerItem.CloseDateName');
				break;
			case MyReport::FIELDTYPE_LASTMODIFIEDDATE:
				$theader[] = Language::getSessText('TrackerItem.LastModifiedDateName');
				break;
			case MyReport::FIELDTYPE_TRACKERNAME:
				$theader[] = Language::getSessText('Tracker.TabString');
				break;
			case MyReport::FIELDTYPE_PROJECTNAME:
				$theader[] = Language::getSessText('Common.Project');
				break;
			default:
				$theader[] = $display_field_name->getFieldName();
				break;
		}
		$headers[] = array('name' => $display_field_name->getFieldName(), 'type' => $display_field_name->getType());
	}

	echo $theme->tableTop($theader);
	
	
	$tmod = array();

	foreach($display_data as $tracker_item_id => $display_fields) {
		$trow = array();
		
		$tracker_item = TrackerItemPeer::retrieveByPk($tracker_item_id);
		$trackerTechs = $tracker_item->getTracker()->getTechnicians();
		
		$assignees = array();
		
		foreach($trackerTechs as $trackerTech) {
			$assignees[$trackerTech->getFirstName() . ' ' . $trackerTech->getLastName()] = $trackerTech;
		}
				
		$trow[] = '<a href="'. GFUrl::getUrl()->projectURL($tracker_item->getTracker()->getProject()->getUnixName(), 'TrackerItemEdit', 'tracker', '', array('tracker_item_id' => $tracker_item_id)) .'" title="'. $tracker_item->getSummary() .'">'. $tracker_item_id .'</a>';
		
		foreach($headers as $header) {
			if(isset($display_fields[$header['name']]) && count($display_fields[$header['name']])>0) {
				$trow_str = '';
				foreach($display_fields[$header['name']] as $row_str ) {
					switch($header['type']) {
						case MyReport::FIELDTYPE_TRACKERNAME:
							$trow_str .= '<a href="'. GFUrl::getUrl()->projectURL($tracker_item->getTracker()->getProject()->getUnixName(), 'TrackerItemBrowse', 'tracker', '', array('tracker_id' => $tracker_item->getTrackerId())) .'" title="'. $row_str .'">'. $row_str .'</a><br>';
							break;
						case MyReport::FIELDTYPE_PROJECTNAME:
							$trow_str .= '<a href="'. GFUrl::getUrl()->projectURL($tracker_item->getTracker()->getProject()->getUnixName(), '', '', '', array()) .'" title="'. $row_str .'">'. $row_str .'</a><br>';
							break;
						case MyReport::FIELDTYPE_ASSIGNEES:
							if(isset($assignees[$row_str])) {
								$trow_str .= '<a href="'. GFUrl::getUrl()->userURL($assignees[$row_str]).'" title="'. $row_str .'">'. $row_str .'</a><br>';
							} else $trow_str .= "$row_str<br>";		
							break;
						default:
							if($header['type'] == TrackerExtraField::TYPE_DATE){
								$dt = date('Y-m-d',  strtotime($row_str));
								$trow_str .= "$dt<br>";	
							} else{
								$trow_str .= "$row_str<br>";}		
							break;
					}
					
				}
				$trow[] = $trow_str;
			}
			else {
				$trow[] = '&nbsp;';
			}
		}
		echo $theme->tableRow($trow, $tmod, false);
	}
}

echo $theme->tableBottom();

$template->footer();
?>
