<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino	jyerfino@gforgegroup.com
 * @date 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */
require_once('lib/core/MyReport.php');
require_once('lib/core/MyReportPeer.php');
require_once("lib/graphics/GraphicPie.php");

$session = Session::getSession();
$Lang = $session->getLanguage();
$user = $session->getUser();

if (isset($_REQUEST['report_id'])) {
	$report_id = Validator::sanitizeInt($_REQUEST['report_id']);
}
else die();

$report = MyReportPeer::retrieveByPK($report_id);

$ids = implode(',', $report->getTrackerItemIds());

if ($ids=='') {
	$ids = '0';
}

$sql = "SELECT \"user\".firstname || ' ' || \"user\".lastname AS username , COUNT(tracker_item.tracker_item_id) AS count 
FROM tracker_item
LEFT JOIN tracker_item_assignee ON tracker_item_assignee.tracker_item_id=tracker_item.tracker_item_id 
LEFT JOIN \"user\" ON \"user\".user_id=tracker_item_assignee.assignee
WHERE tracker_item.tracker_item_id IN ($ids)
GROUP BY username";


$gp = new GraphicPie($Lang->getText('Report.ItemsByAssignee'), 400, 250);
$gp->setSQL($sql);
$gp->setSQLFields('username', 'count');
$gp->showPie();
?>

