<?php
/**
 * Copyright (c) 2005-2008 GForge, LLC
 *
 * @version   $Id$
 * @author Julian Yerfino	jyerfino@gforgegroup.com
 * @date 
 *
 * This file is part of GForge.
 *
 * See LICENSE for details. This file is part of GForge AS and may not be
 * redistributed without written permission of GForge, LLC
 */

require_once ("lib/external/jpgraph/jpgraph.php");
require_once ("lib/external/jpgraph/jpgraph_bar.php");
require_once ("lib/external/jpgraph/jpgraph_canvas.php");

$session = Session::getSession();
$Lang = $session->getLanguage();
$project = GFUrl::getUrl()->getProject();
$project_id = $project->getProjectId();

// Get connection
$con = Propel::getConnection(UserPeer::DATABASE_NAME);
$stmt = $con->createStatement();

// Get release_id
$pkg_rls_id = ((isset($_REQUEST['pkg_rls_id'])) ? $_REQUEST['pkg_rls_id'] : '0,0' );
list ($package_id, $release_id) = explode(',', $pkg_rls_id);

$package_id = Validator::sanitizeInt($package_id);
$release_id = Validator::sanitizeInt($release_id);

$subprojects=((isset($_REQUEST['subprojects'])) ? Validator::sanitizeInt($_REQUEST['subprojects']) : 0 );

$releases = array();
$releases['0,0'] = $Lang->getText('Reporting.FutureReleases');

// Get all Project Ids and Names
$all_ids = array();
$all_names = array();
if ($subprojects == 1) {
	$all_ids = $project->getAllSubprojectIds();
	foreach ($project->getAllSubprojects() as $subPrj) {
		$all_names[$subPrj->getProjectId()] = $subPrj->getProjectName();
	}
	$all_ids[] = $project_id;
	$all_names[$project->getProjectId()] = $project->getProjectName();
} else {
	$all_ids[] = $project_id;
}


$sql = "SELECT COUNT(ti.tracker_id), frsp.package_name || '::' || frsr.release_name as release
FROM frs_package frsp, 
frs_release frsr,
tracker_extra_field tef,
tracker_extra_field_data tefd,
tracker t,
tracker_item ti
WHERE frsr.frs_package_id=frsp.frs_package_id
AND frsp.project_id IN (".implode(',',$all_ids).") 
AND frsr.frs_release_id=tefd.field_data
AND tefd.tracker_extra_field_id=tef.tracker_extra_field_id
AND tefd.tracker_item_id=ti.tracker_item_id
AND ti.tracker_id=t.tracker_id
AND tef.field_name='$foundfixedstr'
AND tef.field_type='".TrackerExtraField::TYPE_RELEASE."'";

if ($pkg_rls_id == '0,0') {
	$sql .= " AND frsr.is_released=false ";
} else {
	$sql .= " AND frsr.frs_package_id='$package_id' AND frsr.frs_release_id = '$release_id' ";
}
$sql .= "GROUP BY release ORDER BY release";

$rs = $stmt->executeQuery($sql);
$data = array();

while($rs->next()) {
	$d = $rs->getRow();
	$data[$d['release']] = $d['count'];
}

/*if (count($data)==0)
{
	$data['not enough data'] = 0;
	$data['not enough data2'] = 1;
}*/

$font = $Lang->getFontProperties(FF_FONT1, FS_NORMAL, 12);
// Create the graph. These two calls are always required


if (count($data)>0) {
	$graph = new Graph(400, 250);
	$graph->title->Set($Lang->getText('ProjectReporting.Items' . str_replace (' ', '', $foundfixedstr)));
	$graph->title->SetFont($font[0], $font[1], $font[2]);
	$graph->setBox(false);
	$graph->setFrame(false);
	$graph->img->SetMargin(40,20,30,80);
	$graph->SetScale("textlin");
	
	$graph->yaxis->scale->SetGrace(0);
	$graph->yaxis->SetLabelMargin(1);
	$graph->yaxis->SetTitle($Lang->getText('ProjectReporting.Items'), 'low');
	$graph->yaxis->title->SetFont(FF_FONT1,FS_BOLD);
	$graph->yaxis->SetTitleMargin(30);
	$graph->xaxis->SetLabelAngle(90);
	$graph->xaxis->SetTickLabels(array_keys($data));
	$graph->xaxis->SetFont(FF_FONT1,FS_BOLD);


	$b = new BarPlot(array_values($data));
	$b->value->Show();
	$b->value->SetFormat('%d');
	$b->SetAbsWidth(15);
	$b->SetWidth(1);
	$graph->Add($b);
}
else {
	// Create a not enough data information available graph

	$graph = new CanvasGraph(400, 30);
	//$graph->setWidth(1);
	//$graph->setHeight(1);

	/*$t1 = new Text($Lang->getText('ProjectReporting.NotEnoughDataToPlot') . "\n" . $Lang->getText('ProjectReporting.Items' . str_replace (' ', '', $foundfixedstr)));
	$t1->SetPos(0.5,0.5);
	$t1->SetAlign('center', 'center', 'center');
	$t1->SetFont($font[0], $font[1], $font[2]);
	$t1->SetBox("white","black",true);
	$t1->SetColor("black");
	$graph->AddText($t1);*/
}


$graph->Stroke(); 
?>
 